Attribute VB_Name = "modC_CodeGen"
Option Explicit
Public Const barra1 As String = "//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" & vbNewLine
Public Const barra2 As String = "// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbNewLine
Public Const CODE_VERSION As String = "v1.5r1"

'Imprime el listado de un grafo
Public Function Listado(grafo As AddFlow) As String
Dim nodo As afNode
Dim link As afLink
Dim s As String
Dim s0 As String
Dim prio As Long
Dim i As Long
    
    s = "[FSM LIST FILE START]" & vbNewLine
    s = s & "[FSM name]" & vbNewLine & _
        Indent(DimeDatoFSM(FSM_NAME, grafo), 4) & vbNewLine
    s = s & "[List version]" & vbNewLine & _
            Indent(CODE_VERSION, 4) & vbNewLine
    s = s & "[Parameters]" & vbNewLine
        s0 = DimeDatoFSM(FSM_PARAMETER, grafo)
        If LenB(s0) Then s = s & Indent(s0, 4) & vbNewLine
    s = s & "[ReturnType]" & vbNewLine
        s0 = DimeDatoFSM(FSM_RETURN_TYPE, grafo)
        If LenB(s0) Then s = s & Indent(s0, 4) & vbNewLine
    s = s & "[Config]" & vbNewLine & _
        Indent("[formatCompilacion][AutoSizeNodes][FixedOnlyFont][HideComments][FunctionInit][FunctionEnd][DebugInfo][AnsiComment][PrintTextBoxes][HistoryFsm][UseBitFields]", 2) & vbNewLine & _
        Indent(DimeDatoFSM(FSM_CONFIG, grafo), 4) & vbNewLine
    s = s & "[Signature]" & vbNewLine & _
        Indent(DimeDatoFSM(FSM_FIRMA, grafo), 4) & vbNewLine
    
    'Propiedades del FSM
    s = s & "[Module header]" & vbNewLine
        s0 = DimeDatoFSM(FSM_MOD_HEADER, grafo)
        If LenB(s0) Then s = s & Indent(s0, 4) & vbNewLine
    s = s & "[Initialization]" & vbNewLine
        s0 = DimeDatoFSM(FSM_GLOBAL_INIT, grafo)
        If LenB(s0) Then s = s & Indent(s0, 4) & vbNewLine
    s = s & "[Function header]" & vbNewLine
        s0 = DimeDatoFSM(FSM_FUN_HEADER, grafo)
        If LenB(s0) Then s = s & Indent(s0, 4) & vbNewLine
    s = s & "[Global actions before dispatcher]" & vbNewLine
        s0 = DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo)
        If LenB(s0) Then s = s & Indent(s0, 4) & vbNewLine
    s = s & "[Global actions after dispatcher]" & vbNewLine
        s0 = DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo)
        If LenB(s0) Then s = s & Indent(s0, 4) & vbNewLine
    s = s & "[Global ending actions]" & vbNewLine
        s0 = DimeDatoFSM(FSM_GLOBAL_END, grafo)
        If LenB(s0) Then s = s & Indent(s0, 4) & vbNewLine
    
    'Busca nodo inicial
    s = s & "[Init state]" & vbNewLine
    For Each nodo In grafo.Nodes
        If EsEstadoInicial(nodo) Then
            s = s & Indent(DimeDatoEstado(ESTADO_NAME, nodo), 4) & vbNewLine
            Exit For
        End If
    Next

    'Busca nodo final
    s = s & "[Final states]" & vbNewLine
    For Each nodo In grafo.Nodes
        If EsEstadoFinal(nodo) Then
            s = s & Indent(DimeDatoEstado(ESTADO_NAME, nodo), 4) & vbNewLine
        End If
    Next
    s = s & "[Nodes]" & vbNewLine
    
    'Detalle de cada nodo
    ReDim strn(1 To grafo.Nodes.count) As String
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
            strn(i) = "  [Index]" & vbNewLine & _
                      Indent(Format$(i), 6) & vbNewLine
            strn(i) = strn(i) & "    [Nombre]" & vbNewLine & _
                      Indent(DimeDatoEstado(ESTADO_NAME, nodo), 8) & vbNewLine
            strn(i) = strn(i) & "    [Generate Goto]" & vbNewLine
            s0 = DimeDatoEstado(FUNCTION_GO_TO, nodo)
                If LenB(s0) Then strn(i) = strn(i) & Indent(s0, 8) & vbNewLine
            strn(i) = strn(i) & "    [Generate IsIn]" & vbNewLine
            s0 = DimeDatoEstado(FUNCTION_IS_IN, nodo)
                If LenB(s0) Then strn(i) = strn(i) & Indent(s0, 8) & vbNewLine
            strn(i) = strn(i) & "    [Entry actions]" & vbNewLine
                s0 = DimeDatoEstado(ACTIONS_ENTRY, nodo)
                If LenB(s0) Then strn(i) = strn(i) & Indent(s0, 8) & vbNewLine
            strn(i) = strn(i) & "    [Moore actions]" & vbNewLine
                s0 = DimeDatoEstado(ACTIONS_MOORE, nodo)
                If LenB(s0) Then strn(i) = strn(i) & Indent(s0, 8) & vbNewLine
            strn(i) = strn(i) & "    [Else actions]" & vbNewLine
                s0 = DimeDatoEstado(ACTIONS_ELSE, nodo)
                If LenB(s0) Then strn(i) = strn(i) & Indent(s0, 8) & vbNewLine
            strn(i) = strn(i) & "    [Exit actions]" & vbNewLine
                s0 = DimeDatoEstado(ACTIONS_EXIT, nodo)
                If LenB(s0) Then strn(i) = strn(i) & Indent(s0, 8) & vbNewLine
            strn(i) = strn(i) & "    [Transitions]" & vbNewLine
            
            For prio = 1 To nodo.OutLinks.count
                For Each link In nodo.OutLinks
                    If prio = Val(DimeDatoTrans(PRIORITY, link.dst)) Then
                        strn(i) = strn(i) & "      [Priority]" & vbNewLine & _
                            Indent(Trim$(DimeDatoTrans(PRIORITY, link.dst)), 10) & vbNewLine
                        strn(i) = strn(i) & "      [Condition]" & vbNewLine
                            s0 = DimeDatoTrans(CONDITIONS, link.dst)
                            If LenB(s0) Then strn(i) = strn(i) & Indent(s0, 10) & vbNewLine
                        strn(i) = strn(i) & "        [Meally actions]" & vbNewLine
                            s0 = DimeDatoTrans(ACTIONS_MEALY, link.dst)
                            If LenB(s0) Then strn(i) = strn(i) & Indent(s0, 12) & vbNewLine
                        strn(i) = strn(i) & "        [Next state]" & vbNewLine & _
                            Indent(DimeDatoEstado(ESTADO_NAME, link.dst.OutLinks(1).dst), 12) & vbNewLine
                        If nodo Is link.dst.OutLinks(1).dst Then
                            strn(i) = strn(i) & "          [EntryExitOnSelfTrans]" & vbNewLine & _
                                Indent(DimeDatoTrans(ENTRY_EXIT_SELF_TRANS, link.dst), 14) & vbNewLine
                        End If
                            strn(i) = strn(i) & "          [ContinueImmediately]" & vbNewLine & _
                            Indent(DimeDatoTrans(CONTINUE_IMMEDIATELY, link.dst), 14) & vbNewLine
                        Exit For
                    End If
                Next
            Next
            strn(i) = strn(i)
        End If
    Next
    For i = 1 To grafo.Nodes.count
        If LenB(strn(i)) Then s = s & strn(i)
    Next
    Listado = s & "[FSM LIST FILE END]"
    
End Function

'Public Function C_CodeGen_Point(grafo As AddFlow, _
'                                bGenFuncInit As Boolean, _
'                                bGenFuncEnd As Boolean, _
'                                bHistory As Boolean, _
'                                bDebug As Boolean, _
'                                bAnsiComm As Boolean, _
'                                bTextBoxesInCode As Boolean) As String
'Dim nodo        As afNode
'Dim link        As afLink
'Dim s           As String, s0         As String, s1         As String
'Dim sProx       As String
'Dim sTrans      As String
'Dim sElse       As String
'Dim sCond       As String
'Dim sNext       As String
'Dim sIni        As String
'Dim sFunIni     As String
'Dim sFuncion    As String
'Dim sParametros As String
'Dim sDipatcher  As String, sPreIndice As String
'Dim sIndice As String
'Dim sEstado As String
'Dim sMacFun As String
'Dim prio As Long
'Dim i As Long
'Dim iMax As Long
'Dim nEsp As Long
'Dim cEnEx As New clsEntryExit
'Dim sHeaderExp2 As String, sHeaderExp1 As String, sHeaderExp0 As String, sHeader As String
'Dim sFun_IsIn_Impl As String
'Dim sFun_Goto_Impl As String
'Dim hayEntry As Boolean
'Dim sEntry As String
'Dim bDesactEnEx As Boolean
'Dim parent As New clsParientes
'Dim j As Long
'Dim sInitChilds As String
'
'    sFuncion = DimeDatoFSM(FSM_NAME, grafo)
'
'    'Captura los parmetros
'    sParametros = Trim$(DimeDatoFSM(FSM_PARAMETER, grafo))
'    If LenB(sParametros) = 0 Then sParametros = "void"
'
'    'Exige que grafo tenga nombre
'    If LenB(sFuncion) = 0 Then
'        MsgBox "Attention, before generate C-code you must name the FSM"
'        C_CodeGen_Point = vbNullString
'        Exit Function
'    End If
'
'    sDipatcher = "Dis_" & sFuncion
'    sPreIndice = "entryFsmFlg"
'
'    sIndice = "ind_" & sFuncion 'Solo para debug
'    sHeaderExp0 = "void " & sFuncion & "(" & sParametros & ");" & vbNewLine
'
'  'Cabecera del FSM
'    s0 = barra1 & _
'              "//  Automatic generated C-code by the application:" & vbNewLine & _
'              "//     " & captionDelPrograma & vbNewLine & _
'              barra1 & _
'              "// Methodology: Pointer to state functions. [" & CODE_VERSION & "]" & vbNewLine & _
'              barra1
'    s = s0 & "// Exported function: " & sHeaderExp0 & _
'             barra1 & vbNewLine
'    sHeaderExp0 = s0 & vbNewLine & "// FSM function." & vbNewLine & sHeaderExp0 & vbNewLine
'
'  'Inicializaciones del FSM
'    'Inserta las inicializaciones creadas por el usuario
'    s0 = DimeDatoFSM(FSM_MOD_HEADER, grafo)
'    If LenB(s0) Then
'        s = s & barra1 & _
'                "// Module header proposed by the user (Start)." & vbNewLine & _
'                barra2 & _
'                PonMarcadoresCpp(AnulaMarcadoresAnsiC(s0)) & _
'                barra2 & _
'                "// Module header proposed by the user (End)." & vbNewLine & _
'                barra1 & vbNewLine
'    End If
'
'    s0 = DimeDatoFSM(FSM_GLOBAL_INIT, grafo)
'    If LenB(s0) Then
'        s = s & barra1 & _
'                "// Initialization proposed by the user (Start)." & vbNewLine & _
'                barra2 & _
'                Indent(s0, 2) & vbNewLine & _
'                barra2 & _
'                "// Initialization proposed by the user (End)." & vbNewLine & _
'                barra1
'    End If
'
'
'
'    'Procesa las acciones {Entry} y {Exit}
'    If cEnEx.ProcesarEntryExit(grafo, hayEntry) Then
'        MsgBox "Attention, the Entry/exit has error(s)"
'        C_CodeGen_Point = vbNullString
'        Exit Function
'    End If
'
'    'Inicializaciones creadas automticamente por el programa
'    s = s & vbNewLine & barra1
'    s = s & "// Automatic initialization (Start)." & vbNewLine
'    s = s & barra2
'
'    'Inserta las definiciones explicitas de las funciones de los Estados
'    s = s & " // States functions declaration." & vbNewLine
'
'    'Localiza el indice del estado inicial
'    For Each nodo In grafo.Nodes
'        If EsEstadoInicial(nodo) Then
'            sFunIni = "E_" & DimeDatoEstado(ESTADO_NAME, nodo)
'            sIni = Format$(Val(DimeDatoEstado(ESTADO_INDICE, nodo)) - 1) 'para modo Debug
'        End If
'    Next
'
'    'Crea listas de Estados ordenados por indice
'    iMax = 0
'    sEstado = vbNullString
'    ReDim strn(1 To grafo.Nodes.count) As String
'    ReDim strEst(1 To grafo.Nodes.count) As String
'    ReDim sEstTxt(1 To grafo.Nodes.count) As String
'    For Each nodo In grafo.Nodes
'        If EsEstado(nodo) Then
'            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
'            sEstado = DimeDatoEstado(ESTADO_NAME, nodo)
'
'            'Declaracin de estados (funciones)
'            strn(i) = "  static void E_" & sEstado & "(" & sParametros & ");" & vbNewLine
'
'            'Memoriza los nombres de todos los estados (para macro "Is_Next_State_Illegal()")
'            iMax = iMax + 1
'            strEst(iMax) = "E_" & sEstado
'
'            'Memoriza posibles funciones "Funcion_IsIn_Estado()"
'            If DimeDatoEstado(FUNCTION_IS_IN, nodo) = "Y" Then
'                'Comn
'                s0 = "// Confirm that the FSM has reached the state:[" & sEstado & "]." & vbNewLine
'                s0 = s0 & "T_u8 " & sFuncion & "_IsIn_" & sEstado & "(void)"
'                'Declaracin
'                sHeaderExp1 = sHeaderExp1 & s0 & ";" & s2NewLine
'                'Implementacin
'                s0 = s0 & vbNewLine & "{" & vbNewLine & _
'                     Space$(4) & "return(" & sDipatcher & " == " & "E_" & sEstado & ");" & vbNewLine & _
'                     "}" & s2NewLine
'                sFun_IsIn_Impl = sFun_IsIn_Impl & s0
'            End If
'
'            'Memoriza posibles funciones "Funcion_Goto_Estado()"
'            If DimeDatoEstado(FUNCTION_GO_TO, nodo) = "Y" Then
'                'Comn
'                s0 = "// Force the FSM to the state:[" & sEstado & "]." & vbNewLine & _
'                     "void " & sFuncion & "_Goto_" & sEstado & "(void)"
'                'Declaracin
'                sHeaderExp2 = sHeaderExp2 & s0 & ";" & s2NewLine
'                'Implementacin
'                s0 = s0 & vbNewLine & "{" & vbNewLine & _
'                     Space$(4) & sDipatcher & " = " & "E_" & sEstado & ";" & vbNewLine
'                If hayEntry Then s0 = s0 & Space$(4) & sPreIndice & " = 0;" & vbNewLine
'                'Zona de Debug info (Implementacin)
'                If bDebug Then
'                    s0 = s0 & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                              Space$(8) & sIndice & " = " & Format$(Val(DimeDatoEstado(ESTADO_INDICE, nodo)) - 1) & ";" & vbNewLine & _
'                              Space$(8) & "debug_transNumber = 0;" & vbNewLine & _
'                              Space$(4) & "#endif" & vbNewLine
'                End If
'                s0 = s0 & "}" & s2NewLine
'                sFun_Goto_Impl = sFun_Goto_Impl & s0
'            End If
'
'            'Recuerda el nombre del estado en orden (para modo debug)
'            sEstTxt(i) = sEstado
'         End If
'    Next
'    For i = 1 To grafo.Nodes.count
'        If LenB(strn(i)) Then s = s & strn(i)
'        strn(i) = vbNullString
'    Next
'
'    'Exige que exista un nodo inicial
'    If LenB(sFunIni) = 0 Then
'        MsgBox "Attention, to generate C-code a start node must be defined"
'        C_CodeGen_Point = vbNullString
'        Exit Function
'    End If
'
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Inserta la definicin del puntero a funciones de Estados
'    s = s & vbNewLine & " // State function pointer." & vbNewLine
'    s = s & "  static void (*" & sDipatcher & ")(" & sParametros & ")= " & sFunIni & ";" & vbNewLine
'    If hayEntry Then s = s & "static T_u8 " & sPreIndice & " = 0;" & vbNewLine
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Zona de Debug info
'    If bDebug Then
'        s0 = vbNewLine & "#if defined(FSM_DEBUG)" & vbNewLine & _
'            Space$(4) & "static T_u8 debug_transNumber = 0;" & vbNewLine & _
'            Space$(4) & "static T_u16 " & sIndice & " = " & sIni & ";" & vbNewLine & _
'            Space$(4) & "static const T_char* debug_stateNames[] = {" & vbNewLine
'        For i = 1 To grafo.Nodes.count
'            If LenB(sEstTxt(i)) Then
'                s0 = s0 & Space$(8) & """" & sEstTxt(i) & """," & vbNewLine
'            End If
'        Next
'        s0 = s0 & Space$(4) & "};" & vbNewLine & _
'                  Space$(4) & "#define FSM_STATE_NAME()   debug_stateNames[" & sIndice & "]" & vbNewLine & _
'                  Space$(4) & "#define FSM_TRANS_NUMBER() debug_transNumber" & vbNewLine & _
'                  Space$(4) & "#define FSM_NAME()         """ & sFuncion & """" & vbNewLine & _
'                  "#else" & vbNewLine & _
'                  Space$(4) & "#define FSM_STATE_NAME()" & vbNewLine & _
'                  Space$(4) & "#define FSM_TRANS_NUMBER()" & vbNewLine & _
'                  Space$(4) & "#define FSM_NAME()" & vbNewLine & _
'                  "#endif" & s2NewLine
'        s = s & s0
'        'Erase sEstTxt
'    End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Zona de macros y funciones opcionales
'    s0 = DimeDatoFSM(FSM_GLOBAL_INIT, grafo) & _
'         DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo) & _
'         DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo) & _
'         DimeDatoFSM(FSM_GLOBAL_END, grafo)
'    If InStr(s0, "Is_Next_State_Illegal()") Then
'        sMacFun = sMacFun & "#define Is_Next_State_Illegal() ( " & sDipatcher & _
'                  " != " & strEst(1)
'        For i = 2 To iMax
'            sMacFun = sMacFun & " && \" & vbNewLine & Space$(34) & sDipatcher & " != " & strEst(i)
'        Next
'        sMacFun = sMacFun & " )" & s2NewLine
'    End If
'    'Function_Init()
'    If bGenFuncInit Or Not bHistory Then
'        'Comn
'        s0 = "// Force the FSM to the initial state." & vbNewLine & _
'             "void " & sFuncion & "_Init(void)"
'        'Declaracin
'        sHeaderExp0 = sHeaderExp0 & s0 & ";" & s2NewLine
'        'Implementacin
'        sMacFun = sMacFun & s0 & vbNewLine & "{" & vbNewLine & _
'                  Space$(4) & sDipatcher & " = " & sFunIni & ";" & vbNewLine
'        If hayEntry Then sMacFun = sMacFun & Space$(4) & sPreIndice & " = 0;" & vbNewLine
'        If bDebug Then
'            sMacFun = sMacFun & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                                Space$(8) & sIndice & " = " & sIni & ";" & vbNewLine & _
'                                Space$(8) & "debug_transNumber = 0;" & vbNewLine & _
'                                Space$(4) & "#endif" & vbNewLine
'        End If
'        sMacFun = sMacFun & "}" & s2NewLine
'    End If
'
'    'History mode
'    s1 = sFuncion & "_Init()"
'    If bHistory Then
'        s0 = "// This is a history FSM." & vbNewLine & _
'             "#define _" & s1 & "  {}" 'The children of a history FSM mustn't need to be initialized
'    Else
'        s0 = "// This is not a history FSM." & vbNewLine & _
'             "#define _" & s1 & "  {" & s1 & "; /* Children: */ " & ChildProcVirtualInitList(grafo) & "}"
'    End If
'    sHeaderExp0 = sHeaderExp0 & s0 & s2NewLine
'
'    'Function_End()
'    If bGenFuncEnd Then
'        'Comn
'        s0 = "// Confirm that the FSM has reached a final state." & vbNewLine & _
'             "T_u8 " & sFuncion & "_End(void)"
'        'Declaracin
'        sHeaderExp0 = sHeaderExp0 & s0 & ";" & s2NewLine
'        'Implementacin
'        sMacFun = sMacFun & s0 & vbNewLine & "{" & vbNewLine & Space$(4) & "return("
'        'Localiza estados finales (Implementacin)
'        s0 = vbNullString
'        For Each nodo In grafo.Nodes
'            If EsEstadoFinal(nodo) Then
'                If LenB(s0) Then s0 = s0 & " ||" & vbNewLine & Space$(11)
'                s0 = s0 & "(" & sDipatcher & " == E_" & DimeDatoEstado(ESTADO_NAME, nodo) & ")"
'            End If
'        Next
'        If LenB(s0) = 0 Then s0 = "0"
'        sMacFun = sMacFun & s0 & ");" & vbNewLine & "}" & s2NewLine
'    End If
'    'Function_IsIn_???()
'    If LenB(sFun_IsIn_Impl) Then sMacFun = sMacFun & sFun_IsIn_Impl
'    'Function_Goto_???()
'    If LenB(sFun_Goto_Impl) Then sMacFun = sMacFun & sFun_Goto_Impl
'    If LenB(sMacFun) Then s = s & vbNewLine & " // Macros & functions." & vbNewLine & sMacFun
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Inserta las definiciones de las funciones {Exit}
'    s0 = cEnEx.DimeDefinicionExitFunc()
'    If LenB(s0) Then
'        s = s & vbNewLine & " // Definition of Exit_functions." & vbNewLine & _
'            Indent(s0, 2) & vbNewLine
'    End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'    'Fin de las inicializaciones creadas por el programa
'    s = s & barra2 & _
'            "// Automatic initialization (End)." & vbNewLine & _
'            barra1
'
'    'Inserta la funcion distribuidora
'    s = s & vbNewLine & barra1 & _
'            "// FSM dispatcher function to be called by the O.S." & vbNewLine & _
'            barra1
'    s0 = DimeDatoFSM(FSM_FUN_HEADER, grafo)
'    If LenB(s0) Then
'        s = s & PonMarcadoresCpp(AnulaMarcadoresAnsiC(s0)) & _
'                barra1
'    End If
'    s = s & "void " & sFuncion & "(" & sParametros & ")" & vbNewLine & "{" & vbNewLine
'
'    'Inserta las acciones globales (antes del dispatcher) creadas por el usuario
'    s0 = DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo)
'    If LenB(s0) Then
'        s = s & Space$(4) & "// User actions to be executed before analyse the state." & vbNewLine & _
'                Indent(s0, 4) & s2NewLine
'    End If
'
'    'Zona de Debug info
'    If bDebug Then
'        s = s & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                Space$(8) & "debug_transNumber = 0;" & vbNewLine & _
'                Space$(4) & "#endif" & vbNewLine
'    End If
'
'    'Inserta la llamada al distribuidor
'    s = s & Space$(4) & "// Next state analyser." & vbNewLine & _
'            Space$(4) & sDipatcher & "(" & EliminaTipos(sParametros) & ");" & vbNewLine
'
'    'Inserta las acciones globales (detrs del dispatcher) creadas por el usuario
'    s0 = DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo)
'    If LenB(s0) Then
'        s = s & vbNewLine & Space$(4) & "// User actions to be executed after analyse the state." & vbNewLine & _
'                Indent(s0, 4) & vbNewLine
'    End If
'
'    'Termina la funcion distribuidora
'    s = s & "}" & s2NewLine
'
'    'Inserta las funciones locales de los estados
'    s = s & vbNewLine & barra1 & _
'            "// States functions." & vbNewLine & _
'            barra1
'
'    'Detalle de cada Estado ordenados por indice
'    For Each nodo In grafo.Nodes
'        If EsEstado(nodo) Then
'            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
'            sEstado = "E_" & DimeDatoEstado(ESTADO_NAME, nodo)
'            'Inicio de la funcion
'            strn(i) = "static void " & sEstado & "(" & sParametros & ")" & vbNewLine & "{" & vbNewLine
'
'            'Carga {Entry}
'            hayEntry = cEnEx.ExisteEntryAccion(i, sEntry)
'            'Si hay {Entry} se debe incluir este check
'            If hayEntry Then
'                strn(i) = strn(i) & _
'                          Space$(4) & "// Entry check" & vbNewLine & _
'                          Space$(4) & "if(" & sPreIndice & " == 0){" & vbNewLine & _
'                          Space$(8) & sPreIndice & " = 1;" & vbNewLine & _
'                          Space$(8) & "// Entry actions" & vbNewLine & _
'                          Indent(sEntry, 8) & vbNewLine & _
'                          Space$(4) & "}" & vbNewLine
'            End If
'
'            'Acciones de Moore
'            s0 = DimeDatoEstado(ACTIONS_MOORE, nodo)
'            If LenB(s0) Then
'                strn(i) = strn(i) & Space$(4) & "// State actions (Moore)." & vbNewLine & _
'                                    Indent(s0, 4) & vbNewLine
'            End If
'
'            'Memoriza acciones else si existen
'            s1 = DimeDatoEstado(ACTIONS_ELSE, nodo)
'            If LenB(s1) Then
'                sElse = "{ // Else actions." & vbNewLine & _
'                        Indent(s1, 8) & vbNewLine & _
'                        Space$(4) & "}"
'            Else
'                sElse = vbNullString
'            End If
'
'            ' Analiza si existen hijos potenciales para aadir coletilla de inicializacion al salir
'            parent.Reset
'            sInitChilds = vbNullString
'            If parent.BuscaEnlaces(s0 & vbNewLine & s1) Then
'                For j = 1 To parent.DimeNumeroHijos
'                    sInitChilds = sInitChilds & "_" & FileSinRutaNiExtension(parent.DimeHijo(j)) & "_Init();" & vbNewLine
'                Next
'                sInitChilds = Space$(8) & "// Child Initialization." & vbNewLine & RTrim$(Indent(sInitChilds, 8))
'            End If
'
'            'Eleccion del proximo estado
'            sProx = Space$(4) & "// Next state selection." & vbNewLine & Space$(4)
'            sTrans = vbNullString
'            For prio = 1 To nodo.OutLinks.count
'                For Each link In nodo.OutLinks
'                    If prio = Val(DimeDatoTrans(PRIORITY, link.dst)) Then
'                        'Abre decisin
'                        sCond = DimeDatoTrans(CONDITIONS, link.dst)
'                        If LenB(Trim$(sCond)) Then
'                            nEsp = IIf(prio > 1, 13, 7)
'                            sTrans = sTrans & "if(" & Indent(sCond & "){", nEsp, False)
'                        Else
'                            If (prio < nodo.OutLinks.count) Or (LenB(sElse) > 0) Then
'                                sTrans = sTrans & "if(1){"
'                            Else
'                                sTrans = sTrans & "{"
'                            End If
'                        End If
'                        If nodo.OutLinks.count > 1 Then
'                            sTrans = sTrans & vbTab & "// [" & DimeDatoTrans(PRIORITY, link.dst) & "]."
'                        End If
'                        sTrans = sTrans & vbNewLine
'
'                        'Crea si procede las acciones {Exit} heredadas
'                        If cEnEx.ExistExitInThisTrans(i, prio, s0, bDesactEnEx) Then
'                            s0 = Space$(8) & "// Exit actions." & vbNewLine & _
'                                 Indent(s0, 8) & vbNewLine
'                        Else
'                            s0 = vbNullString
'                        End If
'
'                        'Inicializacion de hijos al salir
'                        If Not bDesactEnEx Then
'                            sTrans = sTrans & sInitChilds
'                        End If
'
'                        'Aade si procede las acciones {Exit} heredadas
'                        sTrans = sTrans & s0
'
'                        'Acciones de Meally
'                        s0 = DimeDatoTrans(ACTIONS_MEALY, link.dst)
'                        If LenB(s0) Then
'                            sTrans = sTrans & Space$(8) & "// Transition actions (Meally)." & vbNewLine & _
'                                              Indent(s0, 8) & vbNewLine
'                        End If
'
'                        'Apunta el prximo estado
'                        If Not (link.dst.OutLinks(1).dst Is nodo) Then
'                            sNext = "E_" & DimeDatoEstado(ESTADO_NAME, link.dst.OutLinks(1).dst)
'                            sTrans = sTrans & Space$(8) & "// Pointing to the next state." & vbNewLine & _
'                                              Space$(8) & sDipatcher & " = " & sNext & ";" & vbNewLine
'                        End If
'                        'Zona de Debug info
'                        If bDebug Then
'                            sTrans = sTrans & _
'                                    Space$(8) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                                    Space$(12) & sIndice & " = " & Format$(Val(DimeDatoEstado(ESTADO_INDICE, link.dst.OutLinks(1).dst)) - 1) & ";" & vbNewLine & _
'                                    Space$(12) & "debug_transNumber = " & DimeDatoTrans(PRIORITY, link.dst) & ";" & vbNewLine & _
'                                    Space$(8) & "#endif" & vbNewLine
'                        End If
'
'                        'Si hay {Entry} se debe incluir esto
'                        If hayEntry And Not bDesactEnEx Then
'                            sTrans = sTrans & _
'                                     Space$(8) & "// Reset entry flag" & vbNewLine & _
'                                     Space$(8) & sPreIndice & " = 0;" & vbNewLine
'                        End If
'
'                        'Cierra decisin
'                        sTrans = sTrans & Space$(4) & "}else "
'                        Exit For
'                    End If
'                Next
'            Next
'            'Aade transiciones del estado si existen
'            If LenB(sTrans) Then
'                If LenB(sElse) = 0 Then
'                    strn(i) = strn(i) & sProx & Left$(sTrans, Len(sTrans) - 5) & vbNewLine
'                Else
'                    strn(i) = strn(i) & sProx & sTrans & sElse & vbNewLine
'                End If
'            Else
'                If LenB(sElse) Then strn(i) = strn(i) & Space$(4) & sElse & vbNewLine
'            End If
'
'            'Final de la funcion
'            strn(i) = strn(i) & "}" & s2NewLine
'        End If
'    Next
'    For i = 1 To grafo.Nodes.count
'        If LenB(strn(i)) Then s = s & strn(i)
'    Next
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Inserta las implementaciones de las funciones {Exit}
'    s0 = cEnEx.DimeImplementacionExitFunc()
'    If LenB(s0) Then
'        s = s & vbNewLine & " // Implementation of Exit_functions." & vbNewLine & _
'            s0 & vbNewLine
'    End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'    'Inserta las acciones globales finales (fuera de la funcin) creadas por el usuario
'    s0 = DimeDatoFSM(FSM_GLOBAL_END, grafo)
'    If LenB(s0) Then
'        s = s & barra1 & "// Ending code proposed by the user (Start)." & vbNewLine & barra2 & _
'                s0 & vbNewLine & _
'                barra2 & "// Ending code proposed by the user (End)." & vbNewLine & barra1 & vbNewLine
'    End If
'
'    If bTextBoxesInCode Then
'        s = s & barra1 & "// Diagram comments (Start)." & vbNewLine & barra2 & _
'                PrintTextBoxesInCode(grafo) & _
'                barra2 & "// Diagram comments (End)." & vbNewLine & barra1 & vbNewLine
'    End If
'
'    s = s & barra1 & _
'            "//  End of the automatic generated C-code." & vbNewLine & _
'            barra1
'
'    ' Cambia Marcadores si procede
'    sHeader = sHeaderExp0 & sHeaderExp1 & sHeaderExp2
'    If bAnsiComm Then
'        s = MarcadoresAnsiC(s, 80)
'        sHeader = MarcadoresAnsiC(sHeader, 80)
'    End If
'    C_CodeGen_Point = s & SEPARADOR & sHeader & SEPARADOR
'End Function

'Public Function C_CodeGen_TablaPoint(grafo As AddFlow, _
'                                    bGenFuncInit As Boolean, _
'                                    bGenFuncEnd As Boolean, _
'                                    bHistory As Boolean, _
'                                    bDebug As Boolean, _
'                                    bAnsiComm As Boolean, _
'                                    bTextBoxesInCode As Boolean) As String
'Dim nodo As afNode
'Dim link As afLink
'Dim nNodos As Long
'Dim largerDefine As Integer
'Dim numChars As Integer
'Dim s           As String, s0          As String, s1          As String
'Dim sFunc As String
'Dim sArray As String
'Dim sProx As String
'Dim sTrans As String
'Dim sElse As String
'Dim sCond As String
'Dim sNext As String
'Dim sIni As String
'Dim sFuncion As String
'Dim sParametros As String
'Dim sDipatcher As String
'Dim sIndice As String, sPreIndice As String
'Dim sEstado As String
'Dim sDefine As String
'Dim sLastState As String
'Dim sMacFun As String
'Dim prio As Long
'Dim i As Long
'Dim iMax As Long
'Dim nEsp As Long
'Dim cEnEx As New clsEntryExit
'Dim sHeaderExp2 As String, sHeaderExp1 As String, sHeaderExp0 As String, sHeader As String
'Dim sFun_IsIn_Impl As String
'Dim sFun_Goto_Impl As String
'Dim hayEntry As Boolean
'Dim sEntry As String
'Dim bDesactEnEx As Boolean
'Dim parent As New clsParientes
'Dim j As Long
'Dim sInitChilds As String
'
'    sFuncion = DimeDatoFSM(FSM_NAME, grafo)
'
'    'Captura los parmetros
'    sParametros = Trim$(DimeDatoFSM(FSM_PARAMETER, grafo))
'    If LenB(sParametros) = 0 Then sParametros = "void"
'
'    'Exige que grafo tenga nombre
'    If LenB(sFuncion) = 0 Then
'        MsgBox "Attention, before generate C-code you must name the FSM"
'        C_CodeGen_TablaPoint = vbNullString
'        Exit Function
'    End If
'
'    sDipatcher = "Dis_" & sFuncion
'    sIndice = "ind_" & sFuncion
'    sPreIndice = "entryFsmFlg"
'    sDefine = "  #define  i_"
'    sHeaderExp0 = "void " & sFuncion & "(" & sParametros & ");" & vbNewLine
'
'  'Cabecera del FSM
'    s0 = barra1 & _
'              "//  Automatic generated C-code by the application:" & vbNewLine & _
'              "//     " & captionDelPrograma & vbNewLine & _
'              barra1 & _
'              "// Methodology: Array of pointers to state functions. [" & CODE_VERSION & "]" & vbNewLine & _
'              barra1
'    s = s0 & "// Exported function: " & sHeaderExp0 & _
'             barra1 & vbNewLine
'    sHeaderExp0 = s0 & vbNewLine & "// FSM function" & vbNewLine & sHeaderExp0 & vbNewLine
'
'  'Inicializaciones del FSM
'    'Inserta las inicializaciones creadas por el usuario
'    s0 = DimeDatoFSM(FSM_MOD_HEADER, grafo)
'    If LenB(s0) Then
'        s = s & barra1 & _
'                "// Module header proposed by the user (Start)." & vbNewLine & _
'                barra2 & _
'                PonMarcadoresCpp(AnulaMarcadoresAnsiC(s0)) & _
'                barra2 & _
'                "// Module header proposed by the user (End)." & vbNewLine & _
'                barra1 & vbNewLine
'    End If
'
'    s0 = DimeDatoFSM(FSM_GLOBAL_INIT, grafo)
'    If LenB(s0) Then
'        s = s & barra1 & _
'                "// Initialization proposed by the user (Start)." & vbNewLine & _
'                barra2 & _
'                Indent(s0, 2) & vbNewLine & _
'                barra2 & _
'                "// Initialization proposed by the user (End)." & vbNewLine & _
'                barra1
'    End If
'
'    'Inicializaciones creadas automticamente por el programa
'    s = s & vbNewLine & barra1 & _
'            "// Automatic initialization (Start)." & vbNewLine & _
'            barra2
'
'    'Inserta las definiciones de los ndices de los nodos
'    s = s & " // States index." & vbNewLine
'
'    sIni = vbNullString
'    'Busca nombre de estado ms largo y localiza el indice del estado inicial
'    largerDefine = 0
'    nNodos = 0
'    For Each nodo In grafo.Nodes
'        If EsEstado(nodo) Then
'            nNodos = nNodos + 1
'            sEstado = DimeDatoEstado(ESTADO_NAME, nodo)
'            'Busca nombre de estado ms largo
'            If Len(sEstado) > largerDefine Then largerDefine = Len(sEstado)
'            'Localiza el indice del estado inicial
'            If EsEstadoInicial(nodo) Then sIni = "i_" & UCase$(sEstado)
'        End If
'    Next
'    largerDefine = largerDefine + Len(sDefine) + 2
'    If nNodos < 10 Then
'        numChars = 1
'    ElseIf nNodos < 100 Then
'        numChars = 2
'    ElseIf nNodos < 1000 Then
'        numChars = 3
'    Else
'        numChars = 4
'    End If
'
'    'Exige que exista un nodo inicial
'    If LenB(sIni) = 0 Then
'        MsgBox "Attention, to generate C-code a start node must be defined"
'        C_CodeGen_TablaPoint = vbNullString
'        Exit Function
'    End If
'
'    'Procesa las acciones {Entry} y {Exit}
'    If cEnEx.ProcesarEntryExit(grafo, hayEntry) Then
'        MsgBox "Attention, the Entry/exit has error(s)"
'        C_CodeGen_TablaPoint = vbNullString
'        Exit Function
'    End If
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Crea listas de Estados ordenadas por indice
'    nNodos = 0
'    iMax = -1
'    sFunc = vbNullString
'    sArray = vbNullString
'    ReDim strn(1 To grafo.Nodes.count) As String
'    ReDim strFunc(1 To grafo.Nodes.count) As String
'    ReDim strArray(1 To grafo.Nodes.count) As String
'    ReDim sEstTxt(1 To grafo.Nodes.count) As String
'    For Each nodo In grafo.Nodes
'        If EsEstado(nodo) Then
'            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
'            sEstado = DimeDatoEstado(ESTADO_NAME, nodo)
'            'Listas de indices de estados
'            s0 = Left$(sDefine & UCase$(sEstado) & Space$(largerDefine), largerDefine)
'            strn(i) = s0 & Right$(Space$(numChars) & Format$(i - 1), numChars) & vbNewLine
'            nNodos = nNodos + 1
'
'            'Al tiempo crea los estados en el mismo orden
'            'Declaracin de estados
'            strFunc(i) = "  static void E_" & sEstado & "(" & sParametros & ");" & vbNewLine
'
'            'Tabla de estados
'            strArray(i) = Space$(8) & "E_" & sEstado & "," & vbNewLine
'
'            'Busca el estado lmite
'            If iMax < i Then
'                iMax = i
'                sLastState = "i_" & UCase$(sEstado)
'            End If
'
'            'Memoriza posibles funciones "Funcion_IsIn_Estado()"
'            If DimeDatoEstado(FUNCTION_IS_IN, nodo) = "Y" Then
'                'Comn
'                s0 = "// Confirm that the FSM has reached the state:[" & sEstado & "]." & vbNewLine
'                s0 = s0 & "T_u8 " & sFuncion & "_IsIn_" & sEstado & "(void)"
'                'Declaracin
'                sHeaderExp1 = sHeaderExp1 & s0 & ";" & s2NewLine
'                'Implementacin
'                s0 = s0 & vbNewLine & "{" & vbNewLine & _
'                     Space$(4) & "return(" & sIndice & " == i_" & UCase$(sEstado) & ");" & vbNewLine & _
'                     "}" & s2NewLine
'                sFun_IsIn_Impl = sFun_IsIn_Impl & s0
'            End If
'
'            'Memoriza posibles funciones "Funcion_Goto_Estado()"
'            If DimeDatoEstado(FUNCTION_GO_TO, nodo) = "Y" Then
'                'Comn
'                s0 = "// Force the FSM to the state:[" & sEstado & "]." & vbNewLine & _
'                     "void " & sFuncion & "_Goto_" & sEstado & "(void)"
'                'Declaracin
'                sHeaderExp2 = sHeaderExp2 & s0 & ";" & s2NewLine
'                'Implementacin
'                s0 = s0 & vbNewLine & "{" & vbNewLine & _
'                     Space$(4) & sIndice & " = i_" & UCase$(sEstado) & ";" & vbNewLine
'                If hayEntry Then s0 = s0 & Space$(4) & sPreIndice & " = 0;" & vbNewLine
'                'Zona de Debug info (Implementacin)
'                If bDebug Then
'                    s0 = s0 & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                              Space$(4) & "debug_transNumber = 0;" & vbNewLine & _
'                              Space$(4) & "#endif" & vbNewLine
'                End If
'                s0 = s0 & "}" & s2NewLine
'                sFun_Goto_Impl = sFun_Goto_Impl & s0
'            End If
'
'            'Recuerda el nombre del estado en orden (para modo debug)
'            sEstTxt(i) = sEstado
'        End If
'    Next
'    For i = 1 To grafo.Nodes.count
'        If LenB(strn(i)) Then s = s & strn(i)
'        If LenB(strFunc(i)) Then sFunc = sFunc & strFunc(i)
'        If LenB(strArray(i)) Then sArray = sArray & strArray(i)
'        strn(i) = vbNullString
'    Next
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'    'Corrige el final de sArray
'    sArray = Left$(sArray, Len(sArray) - 3) & vbNewLine & "  };" & vbNewLine
'
'    'Inserta las definiciones explicitas de las funciones de los Estados
'    s = s & vbNewLine & " // States functions declaration." & vbNewLine
'    s = s & sFunc & vbNewLine
'
'    'Inserta la tabla de punteros a funciones de Estados
'    s = s & " // Pointer array to states functions." & vbNewLine
'    s = s & "  #pragma INTO_ROM" & vbNewLine
'    s = s & "  static void (*const " & sDipatcher & "[])(" & sParametros & ")= {" & vbNewLine
'    s = s & sArray & vbNewLine
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Inserta la definicin de la variable ndice del FSM
'    s = s & " // Index variable." & vbNewLine
'    If nNodos < 256 Then
'        s = s & "static T_u8 " & sIndice & " = " & sIni & ";" & vbNewLine
'    Else
'        s = s & "static T_u16 " & sIndice & " = " & sIni & ";" & vbNewLine
'    End If
'    If hayEntry Then s = s & "static T_u8 " & sPreIndice & " = 0;"
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Zona de Debug info
'    If bDebug Then
'        s0 = vbNewLine & "#if defined(FSM_DEBUG)" & vbNewLine & _
'             Space$(4) & "static T_u8 debug_transNumber = 0;" & vbNewLine & _
'             Space$(4) & "static const T_char* debug_stateNames[] = {" & vbNewLine
'        For i = 1 To grafo.Nodes.count
'            If LenB(sEstTxt(i)) Then
'                s0 = s0 & Space$(8) & """" & sEstTxt(i) & """," & vbNewLine
'            End If
'        Next
'        s0 = s0 & Space$(4) & "};" & vbNewLine & _
'                  Space$(4) & "#define FSM_STATE_NAME()   debug_stateNames[" & sIndice & "]" & vbNewLine & _
'                  Space$(4) & "#define FSM_TRANS_NUMBER() debug_transNumber" & vbNewLine & _
'                  Space$(4) & "#define FSM_NAME()         """ & sFuncion & """" & vbNewLine & _
'                  "#else" & vbNewLine & _
'                  Space$(4) & "#define FSM_STATE_NAME()" & vbNewLine & _
'                  Space$(4) & "#define FSM_TRANS_NUMBER()" & vbNewLine & _
'                  Space$(4) & "#define FSM_NAME()" & vbNewLine & _
'                  "#endif" & s2NewLine
'        s = s & s0
'        'Erase sEstTxt
'    End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Zona de macros y funciones opcionales
'    s0 = DimeDatoFSM(FSM_GLOBAL_INIT, grafo) & _
'         DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo) & _
'         DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo) & _
'         DimeDatoFSM(FSM_GLOBAL_END, grafo)
'    If InStr(s0, "Is_Next_State_Illegal()") Then
'        sMacFun = sMacFun & "#define Is_Next_State_Illegal() (" & _
'                sIndice & " > " & sLastState & ")" & s2NewLine
'    End If
'    'Function_Init()
'    If bGenFuncInit Or Not bHistory Then
'        'Comn
'        s0 = "// Force the FSM to the initial state." & vbNewLine & _
'             "void " & sFuncion & "_Init(void)"
'        'Declaracin
'        sHeaderExp0 = sHeaderExp0 & s0 & ";" & s2NewLine
'        'Implementacin
'        sMacFun = sMacFun & s0 & vbNewLine & "{" & vbNewLine & _
'                  Space$(4) & sIndice & " = " & sIni & ";" & vbNewLine
'        If hayEntry Then sMacFun = sMacFun & Space$(4) & sPreIndice & " = 0;" & vbNewLine
'        If bDebug Then
'            sMacFun = sMacFun & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                                Space$(8) & "debug_transNumber = 0;" & vbNewLine & _
'                                Space$(4) & "#endif" & vbNewLine
'        End If
'        sMacFun = sMacFun & "}" & s2NewLine
'    End If
'
'    'History mode
'    s1 = sFuncion & "_Init()"
'    If bHistory Then
'        s0 = "// This is a history FSM." & vbNewLine & _
'             "#define _" & s1 & "  {}" 'The children of a history FSM mustn't need to be initialized
'    Else
'        s0 = "// This is not a history FSM." & vbNewLine & _
'             "#define _" & s1 & "  {" & s1 & "; /* Children: */ " & ChildProcVirtualInitList(grafo) & "}"
'    End If
'    sHeaderExp0 = sHeaderExp0 & s0 & s2NewLine
'
'    'Function_End()
'    If bGenFuncEnd Then
'        'Comn
'        s0 = "// Confirm that the FSM has reached a final state." & vbNewLine & _
'             "T_u8 " & sFuncion & "_End(void)"
'        'Declaracin
'        sHeaderExp0 = sHeaderExp0 & s0 & ";" & s2NewLine
'        'Implementacin
'        sMacFun = sMacFun & s0 & vbNewLine & "{" & vbNewLine & Space$(4) & "return("
'        'Localiza estados finales (Implementacin)
'        s0 = vbNullString
'        For Each nodo In grafo.Nodes
'            If EsEstadoFinal(nodo) Then
'                If LenB(s0) Then s0 = s0 & " ||" & vbNewLine & Space$(11)
'                s0 = s0 & "(" & sIndice & " == i_" & UCase$(DimeDatoEstado(ESTADO_NAME, nodo)) & ")"
'            End If
'        Next
'        If LenB(s0) = 0 Then s0 = "0"
'        sMacFun = sMacFun & s0 & ");" & vbNewLine & "}" & s2NewLine
'    End If
'    'Function_IsIn_???()
'    If LenB(sFun_IsIn_Impl) Then sMacFun = sMacFun & sFun_IsIn_Impl
'    'Function_Goto_???()
'    If LenB(sFun_Goto_Impl) Then sMacFun = sMacFun & sFun_Goto_Impl
'    If LenB(sMacFun) Then s = s & vbNewLine & " // Macros & functions." & vbNewLine & sMacFun
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Inserta las definiciones de las funciones {Exit}
'    s0 = cEnEx.DimeDefinicionExitFunc()
'    If LenB(s0) Then
'        s = s & vbNewLine & " // Definition of Exit_functions." & vbNewLine & _
'            Indent(s0, 2) & vbNewLine
'    End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'    'Fin de las inicializaciones creadas por el programa
'    s = s & barra2 & _
'            "// Automatic initialization (End)." & vbNewLine & _
'            barra1
'
'    'Inserta la funcion distribuidora
'    s = s & vbNewLine & barra1 & _
'            "// FSM dispatcher function to be called by the O.S." & vbNewLine & _
'            barra1
'    s0 = DimeDatoFSM(FSM_FUN_HEADER, grafo)
'    If LenB(s0) Then
'        s = s & PonMarcadoresCpp(AnulaMarcadoresAnsiC(s0)) & _
'                barra1
'    End If
'    s = s & "void " & sFuncion & "(" & sParametros & ")" & vbNewLine & "{" & vbNewLine
'
'    'Inserta las acciones globales (antes del dispatcher) creadas por el usuario
'    s0 = DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo)
'    If LenB(s0) Then
'        s = s & Space$(4) & "// User actions to be executed before analyse the state." & vbNewLine & _
'                Indent(s0, 4) & s2NewLine
'    End If
'
'    'Zona de Debug info
'    If bDebug Then
'        s = s & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                Space$(8) & "debug_transNumber = 0;" & vbNewLine & _
'                Space$(4) & "#endif" & vbNewLine
'    End If
'
'    'Inserta la llamada al distribuidor
'    s = s & Space$(4) & "// Next state analyser." & vbNewLine & _
'            Space$(4) & sDipatcher & "[" & sIndice & "](" & EliminaTipos(sParametros) & ");" & vbNewLine
'
'    'Inserta las acciones globales (detrs del dispatcher) creadas por el usuario
'    s0 = DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo)
'    If LenB(s0) Then
'        s = s & vbNewLine & Space$(4) & "// User actions to be executed after analyse the state." & vbNewLine & _
'                Indent(s0, 4) & vbNewLine
'    End If
'
'    'Termina la funcion distribuidora
'    s = s & "}" & s2NewLine
'
'    'Inserta las funciones locales de los estados
'    s = s & vbNewLine & barra1 & _
'            "// States functions." & vbNewLine & _
'            barra1
'
'    'Detalle de cada Estado
'    For Each nodo In grafo.Nodes
'        If EsEstado(nodo) Then
'            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
'            sEstado = "E_" & DimeDatoEstado(ESTADO_NAME, nodo)
'            'Inicio de la funcion
'            strn(i) = "static void " & sEstado & "(" & sParametros & ")" & vbNewLine & "{" & vbNewLine
'
'            'Carga {Entry}
'            hayEntry = cEnEx.ExisteEntryAccion(i, sEntry)
'            'Si hay {Entry} se debe incluir este check
'            If hayEntry Then
'                strn(i) = strn(i) & _
'                          Space$(4) & "// Entry check" & vbNewLine & _
'                          Space$(4) & "if(" & sPreIndice & " == 0){" & vbNewLine & _
'                          Space$(8) & sPreIndice & " = 1;" & vbNewLine & _
'                          Space$(8) & "// Entry actions" & vbNewLine & _
'                          Indent(sEntry, 8) & vbNewLine & _
'                          Space$(4) & "}" & vbNewLine
'            End If
'
'            'Acciones de Moore
'            s0 = DimeDatoEstado(ACTIONS_MOORE, nodo)
'            If LenB(s0) Then
'                strn(i) = strn(i) & Space$(4) & "// State actions (Moore)." & vbNewLine
'                strn(i) = strn(i) & Indent(s0, 4) & vbNewLine
'            End If
'
'            'Memoriza acciones else si existen
'            s1 = DimeDatoEstado(ACTIONS_ELSE, nodo)
'            If LenB(s1) Then
'                sElse = "{ // Else actions." & vbNewLine & _
'                        Indent(s1, 8) & vbNewLine & _
'                        Space$(4) & "}"
'            Else
'                sElse = vbNullString
'            End If
'
'            ' Analiza si existen hijos potenciales para aadir coletilla de inicializacion al salir
'            parent.Reset
'            sInitChilds = vbNullString
'            If parent.BuscaEnlaces(s0 & vbNewLine & s1) Then
'                For j = 1 To parent.DimeNumeroHijos
'                    sInitChilds = sInitChilds & "_" & FileSinRutaNiExtension(parent.DimeHijo(j)) & "_Init();" & vbNewLine
'                Next
'                sInitChilds = Space$(8) & "// Child Initialization." & vbNewLine & RTrim$(Indent(sInitChilds, 8))
'            End If
'
'            'Eleccion del proximo estado
'            sProx = Space$(4) & "// Next state selection." & vbNewLine & Space$(4)
'            sTrans = vbNullString
'            For prio = 1 To nodo.OutLinks.count
'                For Each link In nodo.OutLinks
'                    If prio = Val(DimeDatoTrans(PRIORITY, link.dst)) Then
'                        'Abre decisin
'                        sCond = DimeDatoTrans(CONDITIONS, link.dst)
'                        If LenB(Trim$(sCond)) Then
'                            nEsp = IIf(prio > 1, 13, 7)
'                            sTrans = sTrans & "if(" & Indent(sCond & "){", nEsp, False)
'                        Else
'                            If (prio < nodo.OutLinks.count) Or (LenB(sElse) > 0) Then
'                                sTrans = sTrans & "if(1){"
'                            Else
'                                sTrans = sTrans & "{"
'                            End If
'                        End If
'                        If nodo.OutLinks.count > 1 Then
'                            sTrans = sTrans & vbTab & "// [" & DimeDatoTrans(PRIORITY, link.dst) & "]."
'                        End If
'                        sTrans = sTrans & vbNewLine
'
'                        'Crea si procede las acciones {Exit} heredadas
'                        If cEnEx.ExistExitInThisTrans(i, prio, s0, bDesactEnEx) Then
'                            s0 = Space$(8) & "// Exit actions." & vbNewLine & _
'                                 Indent(s0, 8) & vbNewLine
'                        Else
'                            s0 = vbNullString
'                        End If
'
'                        'Inicializacion de hijos al salir
'                        If Not bDesactEnEx Then
'                            sTrans = sTrans & sInitChilds
'                        End If
'
'                        'Aade si procede las acciones {Exit} heredadas
'                        sTrans = sTrans & s0
'
'                        'Acciones de Meally
'                        s0 = DimeDatoTrans(ACTIONS_MEALY, link.dst)
'                        If LenB(s0) Then
'                            sTrans = sTrans & Space$(8) & "// Transition actions (Meally)." & vbNewLine
'                            sTrans = sTrans & Indent(s0, 8) & vbNewLine
'                        End If
'
'                        'Apunta el prximo estado
'                        If Not link.dst.OutLinks(1).dst Is nodo Then
'                            sNext = "i_" & UCase$(DimeDatoEstado(ESTADO_NAME, link.dst.OutLinks(1).dst))
'                            sTrans = sTrans & Space$(8) & "// Pointing to the next state." & vbNewLine & _
'                                              Space$(8) & sIndice & " = " & sNext & ";" & vbNewLine
'                        End If
'
'                        'Zona de Debug info
'                        If bDebug Then
'                            sTrans = sTrans & _
'                                    Space$(8) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                                    Space$(12) & "debug_transNumber = " & DimeDatoTrans(PRIORITY, link.dst) & ";" & vbNewLine & _
'                                    Space$(8) & "#endif" & vbNewLine
'                        End If
'
'                        'Si hay {Entry} se debe incluir esto
'                        If hayEntry And Not bDesactEnEx Then
'                            sTrans = sTrans & _
'                                     Space$(8) & "// Reset entry flag" & vbNewLine & _
'                                     Space$(8) & sPreIndice & " = 0;" & vbNewLine
'                        End If
'
'                        'Cierra decisin
'                        sTrans = sTrans & Space$(4) & "}else "
'                        Exit For
'                    End If
'                Next
'            Next
'            'Aade transiciones del estado si existen
'            If LenB(sTrans) Then
'                If LenB(sElse) = 0 Then
'                    strn(i) = strn(i) & sProx & Left$(sTrans, Len(sTrans) - 5) & vbNewLine
'                Else
'                    strn(i) = strn(i) & sProx & sTrans & sElse & vbNewLine
'                End If
'            Else
'                If LenB(sElse) Then strn(i) = strn(i) & Space$(4) & sElse & vbNewLine
'            End If
'
'            'Final de la funcion
'            strn(i) = strn(i) & "}" & s2NewLine
'        End If
'    Next
'    For i = 1 To grafo.Nodes.count
'        If LenB(strn(i)) Then s = s & strn(i)
'    Next
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Inserta las implementaciones de las funciones {Exit}
'    s0 = cEnEx.DimeImplementacionExitFunc()
'    If LenB(s0) Then
'        s = s & vbNewLine & " // Implementation of Exit_functions." & vbNewLine & _
'            s0 & vbNewLine
'    End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'    'Inserta las acciones globales finales (fuera de la funcin) creadas por el usuario
'    s0 = DimeDatoFSM(FSM_GLOBAL_END, grafo)
'    If LenB(s0) Then
'        s = s & barra1 & "// Ending code proposed by the user (Start)." & vbNewLine & barra2 & _
'                s0 & vbNewLine & _
'                barra2 & "// Ending code proposed by the user (End)." & vbNewLine & barra1 & vbNewLine
'    End If
'
'    If bTextBoxesInCode Then
'        s = s & barra1 & "// Diagram comments (Start)." & vbNewLine & barra2 & _
'                PrintTextBoxesInCode(grafo) & _
'                barra2 & "// Diagram comments (End)." & vbNewLine & barra1 & vbNewLine
'    End If
'
'    s = s & barra1 & _
'            "//  End of the automatic generated C-code." & vbNewLine & _
'            barra1
'
'    ' Cambia Marcadores si procede
'    sHeader = sHeaderExp0 & sHeaderExp1 & sHeaderExp2
'    If bAnsiComm Then
'        s = MarcadoresAnsiC(s, 80)
'        sHeader = MarcadoresAnsiC(sHeader, 80)
'    End If
'    C_CodeGen_TablaPoint = s & SEPARADOR & sHeader & SEPARADOR
'End Function

'Public Function C_CodeGen_SwitchCase(grafo As AddFlow, _
'                                    bGenFuncInit As Boolean, _
'                                    bGenFuncEnd As Boolean, _
'                                    bHistory As Boolean, _
'                                    bDebug As Boolean, _
'                                    bAnsiComm As Boolean, _
'                                    bTextBoxesInCode As Boolean) As String
'Dim nodo As afNode
'Dim link As afLink
'Dim nNodos As Long
'Dim largerDefine As Integer
'Dim numChars As Integer
'Dim s           As String, s0         As String, s1         As String
'Dim sProx       As String
'Dim sTrans      As String
'Dim sElse       As String
'Dim sCond       As String
'Dim sNext       As String
'Dim sIni        As String
'Dim sFuncion    As String
'Dim sParametros As String
'Dim sIndice     As String, sPreIndice As String
'Dim sEstado     As String
'Dim sDefine     As String
'Dim sLastState  As String
'Dim sMacFun     As String
'Dim prio        As Long
'Dim i           As Long
'Dim iMax        As Long
'Dim nEsp        As Long
'Dim cEnEx       As New clsEntryExit
'Dim sHeaderExp2 As String, sHeaderExp1 As String, sHeaderExp0 As String, sHeader As String
'Dim sFun_IsIn_Impl As String
'Dim sFun_Goto_Impl As String
'Dim hayEntry    As Boolean
'Dim sEntry      As String
'Dim bDesactEnEx As Boolean
'Dim parent      As New clsParientes
'Dim j           As Long
'Dim sInitChilds As String
'Dim sDefault    As String
'
'    sFuncion = DimeDatoFSM(FSM_NAME, grafo)
'
'    'Captura los parmetros
'    sParametros = Trim$(DimeDatoFSM(FSM_PARAMETER, grafo))
'    If LenB(sParametros) = 0 Then sParametros = "void"
'
'    'Exige que grafo tenga nombre
'    If LenB(sFuncion) = 0 Then
'        MsgBox "Attention, before generate C-code you must name the FSM"
'        C_CodeGen_SwitchCase = vbNullString
'        Exit Function
'    End If
'
'    sIndice = "ind_" & sFuncion
'    sPreIndice = "entryFsmFlg"
'    sDefine = "  #define  i_"
'    sHeaderExp0 = "void " & sFuncion & "(" & sParametros & ");" & vbNewLine
'
'  'Cabecera del FSM
'    s0 = barra1 & _
'              "//  Automatic generated C-code by the application:" & vbNewLine & _
'              "//     " & captionDelPrograma & vbNewLine & _
'              barra1 & _
'              "// Methodology: Switch-case state. [" & CODE_VERSION & "]" & vbNewLine & _
'              barra1
'    s = s0 & "// Exported function: " & sHeaderExp0 & _
'             barra1 & vbNewLine
'    sHeaderExp0 = s0 & vbNewLine & "// FSM function." & vbNewLine & sHeaderExp0 & vbNewLine
'
'  'Inicializaciones del FSM
'    'Inserta las inicializaciones creadas por el usuario
'    s0 = DimeDatoFSM(FSM_MOD_HEADER, grafo)
'    If LenB(s0) Then
'        s = s & barra1 & _
'                "// Module header proposed by the user (Start)." & vbNewLine & _
'                barra2 & _
'                PonMarcadoresCpp(AnulaMarcadoresAnsiC(s0)) & _
'                barra2 & _
'                "// Module header proposed by the user (End)." & vbNewLine & _
'                barra1 & vbNewLine
'    End If
'
'    s0 = DimeDatoFSM(FSM_GLOBAL_INIT, grafo)
'    If LenB(s0) Then
'        s = s & barra1 & _
'                "// Initialization proposed by the user (Start)." & vbNewLine & _
'                barra2 & _
'                Indent(s0, 2) & vbNewLine & _
'                barra2 & _
'                "// Initialization proposed by the user (End)." & vbNewLine & _
'                barra1
'    End If
'
'    'Inicializaciones creadas automticamente por el programa
'    s = s & vbNewLine & barra1 & _
'            "// Automatic initialization (Start)." & vbNewLine & _
'            barra2
'
'    'Inserta las definiciones de los ndices de los nodos
'    s = s & " // States index." & vbNewLine
'
'    sIni = vbNullString
'    'Busca nombre de estado ms largo y localiza el indice del estado inicial
'    largerDefine = 0
'    nNodos = 0
'    For Each nodo In grafo.Nodes
'        If EsEstado(nodo) Then
'            nNodos = nNodos + 1
'            sEstado = DimeDatoEstado(ESTADO_NAME, nodo)
'            'Busca nombre de estado ms largo
'            If Len(sEstado) > largerDefine Then largerDefine = Len(sEstado)
'            'Localiza el indice del estado inicial
'            If EsEstadoInicial(nodo) Then sIni = "i_" & UCase$(sEstado)
'        End If
'    Next
'    largerDefine = largerDefine + Len(sDefine) + 2
'    If nNodos < 10 Then
'        numChars = 1
'    ElseIf nNodos < 100 Then
'        numChars = 2
'    ElseIf nNodos < 1000 Then
'        numChars = 3
'    Else
'        numChars = 4
'    End If
'
'    'Exige que exista un nodo inicial
'    If LenB(sIni) = 0 Then
'        MsgBox "Attention, to generate C-code a start node must be defined"
'        C_CodeGen_SwitchCase = vbNullString
'        Exit Function
'    End If
'
'    'Procesa las acciones {Entry} y {Exit}
'    If cEnEx.ProcesarEntryExit(grafo, hayEntry) Then
'        MsgBox "Attention, the Entry/exit has error(s)"
'        C_CodeGen_SwitchCase = vbNullString
'        Exit Function
'    End If
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Crea listas de Estados ordenados por indice
'    nNodos = 0
'    iMax = -1
'    ReDim strn(1 To grafo.Nodes.count) As String
'    ReDim sEstTxt(1 To grafo.Nodes.count) As String
'    For Each nodo In grafo.Nodes
'        If EsEstado(nodo) Then
'            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
'            sEstado = DimeDatoEstado(ESTADO_NAME, nodo)
'
'            'Listas de indices de estados
'            strn(i) = Left$(sDefine & UCase$(sEstado) & Space$(largerDefine), largerDefine) & _
'                      Right$(Space$(numChars) & Format$(i - 1), numChars) & vbNewLine
'            nNodos = nNodos + 1
'            'Busca el estado lmite
'            If iMax < i Then
'                iMax = i
'                sLastState = "i_" & UCase$(sEstado)
'            End If
'
'            'Memoriza posibles funciones "Funcion_IsIn_Estado()"
'            If DimeDatoEstado(FUNCTION_IS_IN, nodo) = "Y" Then
'                'Comn
'                s0 = "// Confirm that the FSM has reached the state:[" & sEstado & "]." & vbNewLine
'                s0 = s0 & "T_u8 " & sFuncion & "_IsIn_" & sEstado & "(void)"
'                'Declaracin
'                sHeaderExp1 = sHeaderExp1 & s0 & ";" & s2NewLine
'                'Implementacin
'                s0 = s0 & vbNewLine & "{" & vbNewLine & _
'                     Space$(4) & "return(" & sIndice & " == i_" & UCase$(sEstado) & ");" & vbNewLine & _
'                     "}" & s2NewLine
'                sFun_IsIn_Impl = sFun_IsIn_Impl & s0
'            End If
'
'            'Memoriza posibles funciones "Funcion_Goto_Estado()"
'            If DimeDatoEstado(FUNCTION_GO_TO, nodo) = "Y" Then
'                'Comn
'                s0 = "// Force the FSM to the state:[" & sEstado & "]." & vbNewLine & _
'                     "void " & sFuncion & "_Goto_" & sEstado & "(void)"
'                'Declaracin
'                sHeaderExp2 = sHeaderExp2 & s0 & ";" & s2NewLine
'                'Implementacin
'                s0 = s0 & vbNewLine & "{" & vbNewLine & _
'                     Space$(4) & sIndice & " = i_" & UCase$(sEstado) & ";" & vbNewLine
'                If hayEntry Then s0 = s0 & Space$(4) & sPreIndice & " = 0;" & vbNewLine
'                'Zona de Debug info (Implementacin)
'                If bDebug Then
'                    s0 = s0 & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                              Space$(8) & "debug_transNumber = 0;" & vbNewLine & _
'                              Space$(4) & "#endif" & vbNewLine
'                End If
'                s0 = s0 & "}" & s2NewLine
'                sFun_Goto_Impl = sFun_Goto_Impl & s0
'            End If
'
'            'Recuerda el nombre del estado en orden (para modo debug)
'            sEstTxt(i) = sEstado
'        End If
'    Next
'    For i = 1 To grafo.Nodes.count
'        If LenB(strn(i)) Then s = s & strn(i)
'        strn(i) = vbNullString
'    Next
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Inserta las definicin de la variable ndice del FSM
'    s = s & vbNewLine & " // Index variable." & vbNewLine
'    If nNodos < 256 Then
'        s = s & "static T_u8 " & sIndice & " = " & sIni & ";" & vbNewLine
'    Else
'        s = s & "static T_u16 " & sIndice & " = " & sIni & ";" & vbNewLine
'    End If
'    If hayEntry Then s = s & "static T_u8 " & sPreIndice & " = 0;" & vbNewLine
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Zona de Debug info
'    If bDebug Then
'        s0 = vbNewLine & "#if defined(FSM_DEBUG)" & vbNewLine & _
'             Space$(4) & "static T_u8 debug_transNumber = 0;" & vbNewLine & _
'             Space$(4) & "static const T_char* debug_stateNames[] = {" & vbNewLine
'        For i = 1 To grafo.Nodes.count
'            If LenB(sEstTxt(i)) Then
'                s0 = s0 & Space$(8) & """" & sEstTxt(i) & """," & vbNewLine
'            End If
'        Next
'        s0 = s0 & Space$(4) & "};" & vbNewLine & _
'                  Space$(4) & "#define FSM_STATE_NAME()   debug_stateNames[" & sIndice & "]" & vbNewLine & _
'                  Space$(4) & "#define FSM_TRANS_NUMBER() debug_transNumber" & vbNewLine & _
'                  Space$(4) & "#define FSM_NAME()         """ & sFuncion & """" & vbNewLine & _
'                  "#else" & vbNewLine & _
'                  Space$(4) & "#define FSM_STATE_NAME()" & vbNewLine & _
'                  Space$(4) & "#define FSM_TRANS_NUMBER()" & vbNewLine & _
'                  Space$(4) & "#define FSM_NAME()" & vbNewLine & _
'                  "#endif" & s2NewLine
'        s = s & s0
'        'Erase sEstTxt
'    End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Zona de macros y funciones opcionales
'    s0 = DimeDatoFSM(FSM_GLOBAL_INIT, grafo) & _
'         DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo) & _
'         DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo) & _
'         DimeDatoFSM(FSM_GLOBAL_END, grafo)
'    If InStr(s0, "Is_Next_State_Illegal()") Then
'        sMacFun = sMacFun & "#define Is_Next_State_Illegal() (" & _
'                sIndice & " > " & sLastState & ")" & s2NewLine
'    End If
'    'Function_Init()
'    If bGenFuncInit Or Not bHistory Then
'        'Comn
'        s0 = "// Force the FSM to the initial state." & vbNewLine & _
'             "void " & sFuncion & "_Init(void)"
'        'Declaracin
'        sHeaderExp0 = sHeaderExp0 & s0 & ";" & s2NewLine
'        'Implementacin
'        sMacFun = sMacFun & s0 & vbNewLine & "{" & vbNewLine & _
'                  Space$(4) & sIndice & " = " & sIni & ";" & vbNewLine
'        If hayEntry Then sMacFun = sMacFun & Space$(4) & sPreIndice & " = 0;" & vbNewLine
'        If bDebug Then
'            sMacFun = sMacFun & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                                Space$(8) & "debug_transNumber = 0;" & vbNewLine & _
'                                Space$(4) & "#endif" & vbNewLine
'        End If
'        sMacFun = sMacFun & "}" & s2NewLine
'    End If
'
'    'History mode
'    s1 = sFuncion & "_Init()"
'    If bHistory Then
'        s0 = "// This is a history FSM." & vbNewLine & _
'             "#define _" & s1 & "  {}" 'The children of a history FSM mustn't need to be initialized
'    Else
'        s0 = "// This is not a history FSM." & vbNewLine & _
'             "#define _" & s1 & "  {" & s1 & "; /* Children: */ " & ChildProcVirtualInitList(grafo) & "}"
'    End If
'    sHeaderExp0 = sHeaderExp0 & s0 & s2NewLine
'
'    'Function_End()
'    If bGenFuncEnd Then
'        'Comn
'        s0 = "// Confirm that the FSM has reached a final state." & vbNewLine & _
'             "T_u8 " & sFuncion & "_End(void)"
'        'Declaracin
'        sHeaderExp0 = sHeaderExp0 & s0 & ";" & s2NewLine
'        'Implementacin
'        sMacFun = sMacFun & s0 & vbNewLine & "{" & vbNewLine & Space$(4) & "return("
'        'Localiza estados finales (Implementacin)
'        s0 = vbNullString
'        For Each nodo In grafo.Nodes
'            If EsEstadoFinal(nodo) Then
'                If LenB(s0) Then s0 = s0 & " ||" & vbNewLine & Space$(11)
'                s0 = s0 & "(" & sIndice & " == i_" & UCase$(DimeDatoEstado(ESTADO_NAME, nodo)) & ")"
'            End If
'        Next
'        If LenB(s0) = 0 Then s0 = "0"
'        sMacFun = sMacFun & s0 & ");" & vbNewLine & "}" & s2NewLine
'    End If
'    'Function_IsIn_???()
'    If LenB(sFun_IsIn_Impl) Then sMacFun = sMacFun & sFun_IsIn_Impl
'    'Function_Goto_???()
'    If LenB(sFun_Goto_Impl) Then sMacFun = sMacFun & sFun_Goto_Impl
'    If LenB(sMacFun) Then s = s & vbNewLine & " // Macros & functions." & vbNewLine & sMacFun
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Inserta las definiciones de las funciones {Exit}
'    s0 = cEnEx.DimeDefinicionExitFunc()
'    If LenB(s0) Then
'        s = s & vbNewLine & " // Definition of Exit_functions." & vbNewLine & _
'            Indent(s0, 2) & vbNewLine
'    End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'    'Fin de las inicializaciones creadas por el programa
'    s = s & barra2 & _
'            "// Automatic initialization (End)." & vbNewLine & _
'            barra1
'
'    'Inserta la funcion distribuidora
'    s = s & vbNewLine & barra1 & _
'            "// FSM dispatcher function to be called by the O.S." & vbNewLine & _
'            barra1
'    s0 = DimeDatoFSM(FSM_FUN_HEADER, grafo)
'    If LenB(s0) Then
'        s = s & PonMarcadoresCpp(AnulaMarcadoresAnsiC(s0)) & _
'                barra1
'    End If
'    s = s & "void " & sFuncion & "(" & sParametros & ")" & vbNewLine & "{" & vbNewLine
'
'    'Inserta las acciones globales (antes del dispatcher) creadas por el usuario
'    s0 = DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo)
'    If LenB(s0) Then
'        s = s & Space$(4) & "// User actions to be executed before analyse the state." & vbNewLine & _
'                Indent(s0, 4) & s2NewLine
'    End If
'
'    'Zona de Debug info
'    If bDebug Then
'        s = s & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                Space$(8) & "debug_transNumber = 0;" & vbNewLine & _
'                Space$(4) & "#endif" & vbNewLine
'    End If
'
'    'Inserta la llamada al distribuidor
'    s = s & Space$(4) & "// Next state analyser." & vbNewLine & _
'            Space$(4) & "switch(" & sIndice & "){" & vbNewLine
'
'    'Detalle de cada Estado ordenados por indice
'    For Each nodo In grafo.Nodes
'        If EsEstado(nodo) Then
'            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
'            sEstado = "i_" & UCase$(DimeDatoEstado(ESTADO_NAME, nodo))
'            'Inicio del caso
'            strn(i) = Space$(8) & "case " & sEstado & ":" & vbNewLine
'
'            'Carga {Entry}
'            hayEntry = cEnEx.ExisteEntryAccion(i, sEntry)
'            'Si hay {Entry} se debe incluir este check
'            If hayEntry Then
'                strn(i) = strn(i) & _
'                          Space$(12) & "// Entry check" & vbNewLine & _
'                          Space$(12) & "if(" & sPreIndice & " == 0){" & vbNewLine & _
'                          Space$(16) & sPreIndice & " = 1;" & vbNewLine & _
'                          Space$(16) & "// Entry actions" & vbNewLine & _
'                          Indent(sEntry, 16) & vbNewLine & _
'                          Space$(12) & "}" & vbNewLine
'            End If
'
'            'Acciones de Moore
'            s0 = DimeDatoEstado(ACTIONS_MOORE, nodo)
'            If LenB(s0) Then
'                strn(i) = strn(i) & Space$(12) & "// State actions (Moore)." & vbNewLine
'                strn(i) = strn(i) & Indent(s0, 12) & vbNewLine
'            End If
'
'            'Memoriza acciones else si existen
'            s1 = DimeDatoEstado(ACTIONS_ELSE, nodo)
'            If LenB(s1) Then
'                sElse = "{ // Else actions." & vbNewLine & _
'                        Indent(s1, 16) & vbNewLine & _
'                        Space$(12) & "}"
'            Else
'                sElse = vbNullString
'            End If
'
'            ' Analiza si existen hijos potenciales para aadir coletilla de inicializacion al salir
'            parent.Reset
'            sInitChilds = vbNullString
'            If parent.BuscaEnlaces(s0 & vbNewLine & s1) Then
'                For j = 1 To parent.DimeNumeroHijos
'                    sInitChilds = sInitChilds & "_" & FileSinRutaNiExtension(parent.DimeHijo(j)) & "_Init();" & vbNewLine
'                Next
'                sInitChilds = Space$(16) & "// Child Initialization." & vbNewLine & RTrim$(Indent(sInitChilds, 16))
'            End If
'
'            'Eleccion del proximo estado
'            sProx = Space$(12) & "// Next state selection." & vbNewLine & Space$(12)
'            sTrans = vbNullString
'            For prio = 1 To nodo.OutLinks.count
'                For Each link In nodo.OutLinks
'                    If prio = Val(DimeDatoTrans(PRIORITY, link.dst)) Then
'                        'Abre decisin
'                        sCond = DimeDatoTrans(CONDITIONS, link.dst)
'                        If LenB(Trim$(sCond)) Then
'                            nEsp = IIf(prio > 1, 21, 15)
'                            sTrans = sTrans & "if(" & Indent(sCond & "){", nEsp, False)
'                        Else
'                            If (prio < nodo.OutLinks.count) Or (LenB(sElse) > 0) Then
'                                sTrans = sTrans & "if(1){"
'                            Else
'                                sTrans = sTrans & "{"
'                            End If
'                        End If
'                        If nodo.OutLinks.count > 1 Then
'                            sTrans = sTrans & vbTab & "// [" & DimeDatoTrans(PRIORITY, link.dst) & "]."
'                        End If
'                        sTrans = sTrans & vbNewLine
'
'                        'Crea si procede las acciones {Exit} heredadas
'                        If cEnEx.ExistExitInThisTrans(i, prio, s0, bDesactEnEx) Then
'                            s0 = Space$(16) & "// Exit actions." & vbNewLine & _
'                                 Indent(s0, 16) & vbNewLine
'                        Else
'                            s0 = vbNullString
'                        End If
'
'                        'Inicializacion de hijos al salir
'                        If Not bDesactEnEx Then
'                            sTrans = sTrans & sInitChilds
'                        End If
'
'                        'Aade si procede las acciones {Exit} heredadas
'                        sTrans = sTrans & s0
'
'                        'Acciones de Meally
'                        s0 = DimeDatoTrans(ACTIONS_MEALY, link.dst)
'                        If LenB(s0) Then
'                            sTrans = sTrans & Space$(16) & "// Transition actions (Meally)." & vbNewLine & _
'                                              Indent(s0, 16) & vbNewLine
'                        End If
'
'                        'Apunta el prximo estado
'                        If Not link.dst.OutLinks(1).dst Is nodo Then
'                            sNext = "i_" & UCase$(DimeDatoEstado(ESTADO_NAME, link.dst.OutLinks(1).dst))
'                            sTrans = sTrans & Space$(16) & "// Pointing to the next state." & vbNewLine & _
'                                              Space$(16) & sIndice & " = " & sNext & ";" & vbNewLine
'                        End If
'                        'Zona de Debug info
'                        If bDebug Then
'                            sTrans = sTrans & _
'                                    Space$(16) & "#if defined(FSM_DEBUG)" & vbNewLine & _
'                                    Space$(20) & "debug_transNumber = " & DimeDatoTrans(PRIORITY, link.dst) & ";" & vbNewLine & _
'                                    Space$(16) & "#endif" & vbNewLine
'                        End If
'
'                        'Si hay {Entry} se debe incluir esto
'                        If hayEntry And Not bDesactEnEx Then
'                            sTrans = sTrans & _
'                                     Space$(16) & "// Reset entry flag" & vbNewLine & _
'                                     Space$(16) & sPreIndice & " = 0;" & vbNewLine
'                        End If
'
'                        'Cierra decisin
'                        sTrans = sTrans & Space$(12) & "}else "
'                        Exit For
'                    End If
'                Next
'            Next
'            'Aade transiciones del estado si existen
'            If LenB(sTrans) Then
'                If LenB(sElse) = 0 Then
'                    strn(i) = strn(i) & sProx & Left$(sTrans, Len(sTrans) - 5) & vbNewLine
'                Else
'                    strn(i) = strn(i) & sProx & sTrans & sElse & vbNewLine
'                End If
'            Else
'                If LenB(sElse) Then strn(i) = strn(i) & Space$(12) & sElse & vbNewLine
'            End If
'
'            'Final de la funcion
'            s0 = Space$(8) & "break;" & vbNewLine
'            strn(i) = strn(i) & s0
'        End If
'    Next
'    For i = 1 To grafo.Nodes.count
'        If LenB(strn(i)) Then s = s & strn(i)
'    Next
'
'    'Add default case if it's necessary
'    sDefault = DimeDatoFSM(FSM_GLOBAL_DEFAULT, grafo)
'    If LenB(sDefault) Then
'        s = s & Space$(8) & "default:" & vbNewLine & _
'                Space$(12) & "// State index error trap (MISRA requiremment)." & vbNewLine & _
'                Indent(sDefault, 12) & vbNewLine
'    End If
'    s = s & Space$(4) & "}" & vbNewLine
'
'    'Inserta las acciones globales (detrs del dispatcher) creadas por el usuario
'    s0 = DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo)
'    If LenB(s0) Then
'        s = s & vbNewLine & Space$(4) & "// User actions to be executed after analyse the state." & vbNewLine & _
'                Indent(s0, 4) & vbNewLine
'    End If
'
'    'Termina la funcion distribuidora
'    s = s & "}" & s2NewLine
'
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    'Inserta las implementaciones de las funciones {Exit}
'    s0 = cEnEx.DimeImplementacionExitFunc()
'    If LenB(s0) Then
'        s = s & vbNewLine & " // Implementation of Exit_functions." & vbNewLine & _
'            s0 & vbNewLine
'    End If
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'    'Inserta las acciones globales finales (fuera de la funcin) creadas por el usuario
'    s0 = DimeDatoFSM(FSM_GLOBAL_END, grafo)
'    If LenB(s0) Then
'        s = s & barra1 & "// Ending code proposed by the user (Start)." & vbNewLine & barra2 & _
'                s0 & vbNewLine & _
'                barra2 & "// Ending code proposed by the user (End)." & vbNewLine & barra1 & vbNewLine
'    End If
'
'    If bTextBoxesInCode Then
'        s = s & barra1 & "// Diagram comments (Start)." & vbNewLine & barra2 & _
'                PrintTextBoxesInCode(grafo) & _
'                barra2 & "// Diagram comments (End)." & vbNewLine & barra1 & vbNewLine
'    End If
'
'    s = s & barra1 & _
'            "//  End of the automatic generated C-code." & vbNewLine & _
'            barra1
'
'    ' Cambia Marcadores si procede
'    sHeader = sHeaderExp0 & sHeaderExp1 & sHeaderExp2
'    If bAnsiComm Then
'        s = MarcadoresAnsiC(s, 80)
'        sHeader = MarcadoresAnsiC(sHeader, 80)
'    End If
'    C_CodeGen_SwitchCase = s & SEPARADOR & sHeader & SEPARADOR
'End Function


'Public Function EliminaTipos(sParametros As String) As String
'Dim i As Long
'Dim c As String
'Dim esTipo As Boolean
'
'    'Copia solo las variables o "void"
'    EliminaTipos = vbNullString
'    esTipo = False
'    For i = Len(sParametros) To 1 Step -1
'        'Lee el siguiente char por la derecha
'        c = Mid$(sParametros, i, 1)
'
'        'Distingue si esta leyendo un tipo o una variable
'        If esTipo Then
'            'Espera hasta encontrar el prximo fin de tipo
'            If c = "," Then
'                esTipo = False
'            End If
'        Else
'            'Espera hasta encontrar el prximo fin de variable
'            If c = " " Or c = "*" Then
'                esTipo = True
'            Else
'                'Aade por la izquierda
'                EliminaTipos = c + EliminaTipos
'            End If
'        End If
'    Next
'
'    'Elimina el tipo "void"
'    If EliminaTipos = "void" Then
'        EliminaTipos = vbNullString
'    End If
'
'    'Devuelve la variable sin tipos
'End Function

Public Function PrintTextBoxesInCode(grafo As AddFlow) As String
Dim nodo As afNode
Dim s As String

    'Localiza los nodos de texto
    With grafo
        .LogicalOnly = False
        For Each nodo In .Nodes
            If EsComentario(nodo) Then
                s = s & vbNewLine & _
                        AnulaMarcadoresAnsiC(nodo.Text) & _
                        vbNewLine
            End If
        Next
        .LogicalOnly = True
    End With

    If LenB(s) Then
        PrintTextBoxesInCode = "/*" & vbNewLine & s & vbNewLine & "*/" & vbNewLine
    End If
End Function


'Generate a list of virtual initialization of all child processes
Public Function ChildProcVirtualInitList(grafo As AddFlow) As String
Dim nodo As afNode
Dim parent As New clsParientes
Dim i As Long
Dim s As String
    'Seek in all state nodes looking for child states
    ChildProcVirtualInitList = vbNullString
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            ' Analiza si existen hijos potenciales para aadir coletilla de inicializacion al salir
            parent.Reset
            If parent.BuscaEnlaces(DimeDatoEstado(ACTIONS_MOORE, nodo) & vbNewLine & _
                                   DimeDatoEstado(ACTIONS_ELSE, nodo)) Then
                For i = 1 To parent.DimeNumeroHijos
                    s = "_" & FileSinRutaNiExtension(parent.DimeHijo(i)) & "_Init(); "
                    If InStr(ChildProcVirtualInitList, s) = 0 Then
                        ChildProcVirtualInitList = ChildProcVirtualInitList & s
                    End If
                Next
            End If
        End If
    Next
    ChildProcVirtualInitList = RTrim$(ChildProcVirtualInitList)
End Function


Public Function AddHeaderGuard(grafo As AddFlow, sHeader As String) As String
    Dim sGuardNAme As String
    sGuardNAme = UCase(DimeDatoFSM(FSM_NAME, grafo)) & "_H"
    
    AddHeaderGuard = "#ifndef " & sGuardNAme & vbNewLine & _
                     "#define " & sGuardNAme & vbNewLine & _
                     Indent(sHeader, 4) & _
                     "#endif" & vbNewLine
End Function

