Attribute VB_Name = "modC_CodeGenHSC"
Option Explicit
Private sMainFsmName As String

Public Function Generate_C_code_Hierarchical(frmDocActivo As frmDoc) As String
Dim sManInit As String, sAutoDefInit As String, sLocalFuncDec As String, sEntryFlags As String
Dim sDispatcher As String, sTail As String, sHeader As String
ReDim sChildList(1 To 1) As String

    sMainFsmName = DimeDatoFSM(FSM_NAME, frmDocActivo.AddFlow1)

    'Genera el cdigo del padre
    With frmDocActivo
        If Generate_C_code_Hierarchical_I(frmDocActivo, .bDebugInfo, .bTextBoxesInCode, .bUseBitFields, True, sManInit, _
                                         sAutoDefInit, sLocalFuncDec, sEntryFlags, sDispatcher, sTail, _
                                        sHeader, vbNullString, sChildList()) Then

            If .bUseBitFields And (LenB(sEntryFlags) > 0) Then
                sEntryFlags = "typedef struct {" & vbNewLine & _
                              sEntryFlags & _
                              "} T_EntryFsmFlg;" & vbNewLine & _
                              "static T_EntryFsmFlg entryFsm;" & vbNewLine
            End If

            Generate_C_code_Hierarchical = _
                                sManInit & vbNewLine & _
                                barra2 & "// Initialization proposed by the user (End)." & vbNewLine & barra1 & vbNewLine & _
                                barra1 & "// Entry flags (Start)." & vbNewLine & barra2 & _
                                Indent(RemoveTrailingCrLf(sEntryFlags), 2) & vbNewLine & _
                                barra2 & "// Entry flags (End)." & vbNewLine & barra1 & vbNewLine & _
                                barra1 & "// Automatic initialization (Start)." & vbNewLine & barra2 & _
                                RTrim$(sAutoDefInit) & _
                                barra2 & "// Automatic initialization (End)." & vbNewLine & barra1 & vbNewLine & _
                                barra1 & "// Local child functions  (Start)." & vbNewLine & barra2 & _
                                Indent(RemoveTrailingCrLf(sLocalFuncDec), 2) & vbNewLine & _
                                barra2 & "// Local child functions  (End)." & vbNewLine & barra1 & _
                                sDispatcher & vbNewLine & _
                                barra1 & "// Ending code proposed by the user (Start)." & vbNewLine & barra2 & _
                                sTail & vbNewLine & _
                                barra2 & "// Ending code proposed by the user (End)." & vbNewLine & barra1 & _
                                barra1 & "//  End of the automatic generated C-code." & vbNewLine & barra1 & _
                                SEPARADOR & AddHeaderGuard(.AddFlow1, sHeader) & SEPARADOR
                                        
            ' Cambia Marcadores si procede
            If .bAnsiComment Then
                Generate_C_code_Hierarchical = MarcadoresAnsiC(Generate_C_code_Hierarchical, 80)
            End If
        End If
    End With
End Function

    
Private Function Generate_C_code_Hierarchical_I(activeFrmDoc As frmDoc, _
                                             bDebug As Boolean, _
                                             bTextBoxesInCode As Boolean, _
                                             bEntrysAreBitfield As Boolean, _
                                             bIsParent As Boolean, _
                                             sManInit As String, _
                                             sAutoDefInit As String, _
                                             sLocalFuncDec As String, _
                                             sEntryFlags As String, _
                                             sDispatcher As String, _
                                             sTail As String, _
                                             sHeader As String, _
                                             sDiferenciator As String, _
                                             sChildList() As String _
                                             ) As Boolean
Dim ssManInit As String, ssAutoDefInit As String, ssLocalFuncDec As String, ssDispatcher As String
Dim ssTail As String, ssHeader As String, ssAutoDebugInit As String, ssEntryFlags As String
Dim i As Long, j As Long
Dim parent As New clsParientes
Dim s As String

    'Genera el cdigo del padre
    With activeFrmDoc
        Generate_C_code_Hierarchical_I = C_CodeGen_HierarchicalSwitchCase(.AddFlow1, .bGeneraFuncInit, .bGeneraFuncEnd, _
                                            .bHistoryFsm, bDebug, bTextBoxesInCode, bEntrysAreBitfield, Not .bUseMacros, _
                                            bIsParent, sDiferenciator, ssManInit, ssAutoDefInit, ssLocalFuncDec, _
                                            ssDispatcher, ssTail, ssHeader, ssEntryFlags, ssAutoDebugInit)
    End With
    
    sHeader = vbNullString
    sTail = vbNullString
    sLocalFuncDec = vbNullString
    If bIsParent Then
        sManInit = ssManInit
        sAutoDefInit = ssAutoDefInit
        sEntryFlags = ssEntryFlags
        sDispatcher = ssAutoDebugInit & ssDispatcher
        sHeader = ssHeader
        If Len(ssTail) Then
            sTail = vbNewLine & ssTail
        End If
    Else
        s = mainFrm.ActiveForm.Caption & "]"
        sManInit = s & vbNewLine & ssManInit
        sAutoDefInit = s & vbNewLine & ssAutoDefInit
        sLocalFuncDec = ssLocalFuncDec & vbNewLine
        sEntryFlags = ssEntryFlags
        sDispatcher = s & vbNewLine & ssAutoDebugInit & ssDispatcher
        sHeader = s & vbNewLine & ssHeader
        If Len(ssTail) Then
            sTail = s & vbNewLine & ssTail
        End If
    End If
    
    'Add member to the child trim list
    sChildList(UBound(sChildList)) = DimeDatoFSM(FSM_NAME, activeFrmDoc.AddFlow1)
    ReDim Preserve sChildList(1 To UBound(sChildList) + 1)


    s = vbNewLine & "// [Child:"
    
    'Rastrea todos hijos
    'Busca todos hijos posibles
    parent.BuscaTodosEnlaces activeFrmDoc.AddFlow1
    For i = 1 To parent.DimeNumeroHijos
        'Open the child
        FileOpen parent.RutaCompleta(parent.DimeHijo(i))
        Set activeFrmDoc = mainFrm.ActiveForm
    
        ' Child trim check to avoid duplication
        For j = 1 To UBound(sChildList) - 1
            If sChildList(j) = DimeDatoFSM(FSM_NAME, activeFrmDoc.AddFlow1) Then Exit For
        Next
        
        #If DEBUG_ExtendLogOut Then
            'Debug.Assert j = UBound(sChildList)
            Logout " Generate_C_code_Hierarchical_I: SubFSM" & DimeDatoFSM(FSM_NAME, activeFrmDoc.AddFlow1) & " :->" & IIf(j = UBound(sChildList), "Acepted", "Rejected")
        #End If
        
        If j = UBound(sChildList) Then
            Generate_C_code_Hierarchical_I = Generate_C_code_Hierarchical_I And _
                    Generate_C_code_Hierarchical_I(activeFrmDoc, bDebug, bTextBoxesInCode, _
                                                   bEntrysAreBitfield, False, ssManInit, ssAutoDefInit, _
                                                   ssLocalFuncDec, ssEntryFlags, ssDispatcher, _
                                                   ssTail, ssHeader, sDiferenciator & "_" & Format$(i), _
                                                   sChildList())
            If Generate_C_code_Hierarchical_I Then
                sHeader = sHeader & s & " " & ssHeader
                sManInit = sManInit & s & Indent(ssManInit, 2)
                sAutoDefInit = sAutoDefInit & s & Indent(ssAutoDefInit, 2)
                sLocalFuncDec = sLocalFuncDec & ssLocalFuncDec
                sEntryFlags = sEntryFlags & ssEntryFlags
                sDispatcher = sDispatcher & s & Indent(ssDispatcher, 2)
                If Len(ssTail) Then
                    sTail = sTail & s & Indent(ssTail, 2)
                End If
            End If
        End If
    Next
End Function

Private Function C_CodeGen_HierarchicalSwitchCase(grafo As AddFlow, _
                                                  bGenFuncInit As Boolean, _
                                                  bGenFuncEnd As Boolean, _
                                                  bHistory As Boolean, _
                                                  bDebug As Boolean, _
                                                  bTextBoxesInCode As Boolean, _
                                                  bUseBitfield As Boolean, _
                                                  bExportApis As Boolean, _
                                                  bIsParent As Boolean, _
                                                  sDifer As String, _
                                                  sManInit As String, _
                                                  sAutoDefInit As String, _
                                                  sLocalFuncDec As String, _
                                                  sDispatcher As String, _
                                                  sTail As String, _
                                                  sHeader As String, _
                                                  sEntryFlags As String, _
                                                  sAutoDebugInit As String) As Boolean
Dim nodo        As afNode
Dim link        As afLink
Dim nNodos      As Long
Dim largerDefine As Integer
Dim numChars    As Integer
Dim s           As String, s0 As String, s1 As String, s2 As String
Dim sHeader0    As String
Dim sHeader1    As String
Dim sHeaderExp2 As String, sHeaderExp1 As String, sHeaderExp0 As String
Dim sProx       As String
Dim sTrans      As String
Dim sElse       As String
Dim sCond       As String
Dim sNext       As String
Dim sIni        As String
Dim sFuncion    As String
Dim sReturnType As String
Dim sParametros As String
Dim sIndice     As String, sPreIndice As String
Dim sVarCast    As String
Dim sDebugTransNumber As String
Dim sDebugStateNames As String
Dim sEstado     As String
Dim sDefine     As String
Dim sLastState  As String
Dim sMacFun     As String
Dim prio        As Long
Dim i           As Long
Dim iMax        As Long
Dim nEsp        As Long
Dim cEnEx       As New clsEntryExit
Dim sFun_IsIn_Impl As String
Dim sFun_Goto_Impl As String
Dim hayEntry    As Boolean
Dim sEntry      As String
Dim bDesactEnEx As Boolean
Dim parent      As New clsParientes
Dim j           As Long
Dim sInitChilds As String
Dim sDefault    As String
Dim s_IsIn      As String
Dim s_Goto      As String
Dim s_Init      As String
Dim s_InitV     As String
Dim s_End       As String
Dim s_IsInF     As String
Dim s_GotoF     As String
Dim s_InitF     As String
Dim s_EndF      As String

'ContImm
Dim cContImm    As New clsContinueImmediately
Dim hayContImm  As Boolean
Dim iMaxLoops   As Long
Dim nSpcContInt As Long
Dim sContImm    As String
Dim sMaxLoops   As String

    
    sFuncion = DimeDatoFSM(FSM_NAME, grafo)
    s_InitV = sFuncion & "_Init()"
    If bExportApis Then
        s_IsIn = sFuncion & "__IsIn_"
        s_Goto = sFuncion & "__Goto_"
        s_Init = sFuncion & "__Init()"
        s_End = sFuncion & "__End()"
        s_IsInF = sFuncion & "_IsIn_"
        s_GotoF = sFuncion & "_Goto_"
        s_InitF = sFuncion & "_Init(void)"
        s_EndF = sFuncion & "_End(void)"
    Else
        s_IsIn = sFuncion & "_IsIn_"
        s_Goto = sFuncion & "_Goto_"
        s_Init = sFuncion & "_Init()"
        s_End = sFuncion & "_End()"
    End If
    
    'Captura los parmetros
    sParametros = Trim$(DimeDatoFSM(FSM_PARAMETER, grafo))
    If LenB(sParametros) = 0 Then sParametros = "void"
    
    'Capture the return type
    sReturnType = Trim$(DimeDatoFSM(FSM_RETURN_TYPE, grafo))
    If LenB(sReturnType) = 0 Then sReturnType = "void"
    
    'Exige que grafo tenga nombre
    If LenB(sFuncion) = 0 Then
        MsgBox "Attention, before generate C-code you must name the FSM"
        C_CodeGen_HierarchicalSwitchCase = False
        Exit Function
    End If
    
    sIndice = "ind" & sDifer & "_" & sFuncion
    If bUseBitfield Then
        sPreIndice = "entryFsm.flg" & sDifer
    Else
        sPreIndice = "entryFsmFlg" & sDifer
    End If
    sDebugTransNumber = "debug_transNumber" & sDifer
    sDebugStateNames = "debug_stateNames" & sDifer
    sDefine = "  #define  i" & sDifer & "_"
    
    If bIsParent Then
        sHeader0 = sReturnType & " " & sFuncion & "(" & sParametros & ");" & vbNewLine
    Else
        sLocalFuncDec = "static " & sReturnType & " " & sFuncion & "(" & sParametros & ");"
    End If
    
    'Cabecera del FSM
      s0 = barra1 & _
           "//  Automatic generated C-code by the application:" & vbNewLine & _
           "//     " & captionDelPrograma & vbNewLine & _
           barra1 & _
           "// Methodology: Hierarchical Switch-case state. [" & CODE_VERSION & "]" & vbNewLine & _
           barra1
      s = s0 & "// Exported function: " & sHeader0 & _
               barra1 & vbNewLine
    
  'Inicializaciones del FSM
    'Inserta las inicializaciones creadas por el usuario
    s1 = DimeDatoFSM(FSM_MOD_HEADER, grafo)
    If LenB(s1) Then
        s1 = barra1 & _
            "// Module header proposed by the user (Start)." & vbNewLine & _
            barra2 & _
            PonMarcadoresCpp(AnulaMarcadoresAnsiC(s1)) & _
            barra2 & _
            "// Module header proposed by the user (End)." & vbNewLine & _
            barra1 & vbNewLine
    End If
    
    s = s & s1

    If bIsParent Then
        sHeader1 = s0 & vbNewLine & s1 & vbNewLine
    End If

    s0 = DimeDatoFSM(FSM_GLOBAL_INIT, grafo)
    If bIsParent Then
        s = s & barra1 & _
               "// Initialization proposed by the user (Start)." & vbNewLine & _
                barra2 & _
                Indent(s0, 2) & vbNewLine
    Else
        s = Indent(s0, 2) & vbNewLine
    End If
    
    sManInit = s
    s = vbNullString
    
'    If bIsParent Then
'        'Inserta llamada al header para verificar tipos
'        s = s & " // Self prototypes ." & vbNewLine & _
'                "  #include """ & sMainFsmName & ".h""" & s2NewLine
'    End If
    
    'Inserta las definiciones de los ndices de los nodos
    s = s & " // States index." & vbNewLine
    
    sIni = vbNullString
    'Busca nombre de estado ms largo y localiza el indice del estado inicial
    largerDefine = 0
    nNodos = 0
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            nNodos = nNodos + 1
            sEstado = DimeDatoEstado(ESTADO_NAME, nodo)
            'Busca nombre de estado ms largo
            If Len(sEstado) > largerDefine Then largerDefine = Len(sEstado)
            'Localiza el indice del estado inicial
            If EsEstadoInicial(nodo) Then sIni = "i" & sDifer & "_" & UCase$(sEstado)
        End If
    Next
    largerDefine = largerDefine + Len(sDefine) + 2
    If nNodos < 10 Then
        numChars = 1
    ElseIf nNodos < 100 Then
        numChars = 2
    ElseIf nNodos < 1000 Then
        numChars = 3
    Else
        numChars = 4
    End If
    If nNodos < 256 Then
        sVarCast = "(T_u8)"
    Else
        sVarCast = "(T_u16)"
    End If
    
    'Exige que exista un nodo inicial
    If LenB(sIni) = 0 Then
        MsgBox "Attention, to generate C-code a start node must be defined"
        C_CodeGen_HierarchicalSwitchCase = False
        Exit Function
    End If
    
    'Procesa las acciones {Entry} y {Exit}
    If cEnEx.ProcesarEntryExit(grafo, hayEntry) Then
        MsgBox "Attention, the Entry/exit has error(s)"
        C_CodeGen_HierarchicalSwitchCase = False
        Exit Function
    End If
    
    'Procesa la opcion "ContinueImmediately"
    Call cContImm.Captura(grafo, hayContImm, iMaxLoops)
        
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Crea listas de Estados ordenados por indice
    nNodos = 0
    iMax = -1
    ReDim strn(1 To grafo.Nodes.count) As String
    ReDim sEstTxt(1 To grafo.Nodes.count) As String
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
            sEstado = DimeDatoEstado(ESTADO_NAME, nodo)
            
            'Listas de indices de estados
            strn(i) = Left$(sDefine & UCase$(sEstado) & Space$(largerDefine), largerDefine) & _
                      "(" & sVarCast & Right$(Space$(numChars) & Format$(i - 1), numChars) & ")" & vbNewLine
            nNodos = nNodos + 1
            'Busca el estado lmite
            If iMax < i Then
                iMax = i
                sLastState = "i" & sDifer & "_" & UCase$(sEstado)
            End If
            
            'Memoriza posibles funciones "Funcion_IsIn_Estado()"
            If DimeDatoEstado(FUNCTION_IS_IN, nodo) = "Y" Then
                s0 = "// Confirm that the FSM has reached the state:[" & sEstado & "]." & vbNewLine
                'Macro implementation
                sFun_IsIn_Impl = sFun_IsIn_Impl & s0 & _
                                 "#define " & s_IsIn & sEstado & "() (" & sIndice & " == i" & sDifer & "_" & UCase$(sEstado) & ")" & s2NewLine
                If bExportApis Then
                    s1 = "T_u8 " & s_IsInF & sEstado & "(void)"
                    'Function declaration
                    sHeaderExp1 = sHeaderExp1 & s0 & _
                                  s1 & ";" & s2NewLine
                    'Function implementation
                    sFun_IsIn_Impl = sFun_IsIn_Impl & s1 & vbNewLine & _
                                    "{" & vbNewLine & _
                                    Space$(4) & "return(" & s_IsIn & sEstado & "());" & vbNewLine & _
                                    "}" & s2NewLine
                End If
            End If
            s0 = vbNullString: s1 = vbNullString
            
            'Memoriza posibles funciones "Funcion_Goto_Estado()"
            If DimeDatoEstado(FUNCTION_GO_TO, nodo) = "Y" Then
                s0 = "// Force the FSM to the state:[" & sEstado & "]." & vbNewLine
                'Macro implementation
                s1 = "#define " & s_Goto & sEstado & "() { " & sIndice & " = i" & sDifer & "_" & UCase$(sEstado) & "; "
                If bDebug Then
                    s2 = "#if defined(FSM_DEBUG)" & vbNewLine & _
                         Space$(4) & s1
                    If hayEntry Then s2 = s2 & sPreIndice & " = 0U; "
                    s2 = s2 & sDebugTransNumber & " = (T_u8)0U; }" & vbNewLine & _
                         "#else" & vbNewLine & Space$(4)
                Else
                    s2 = vbNullString
                End If
                s1 = s2 & s1
                If hayEntry Then s1 = s1 & sPreIndice & " = 0U; "
                s1 = s1 & "}" & vbNewLine
                If bDebug Then s1 = s1 & "#endif" & vbNewLine
                sFun_Goto_Impl = sFun_Goto_Impl & s0 & s1 & vbNewLine
                s1 = vbNullString: s2 = vbNullString
                'Function
                If bExportApis Then
                    s1 = "void " & s_GotoF & sEstado & "(void)"
                    'Function declaration
                    sHeaderExp2 = sHeaderExp2 & s0 & _
                                  s1 & ";" & s2NewLine
                    'Function implementation
                    sFun_Goto_Impl = sFun_Goto_Impl & s1 & vbNewLine & _
                                    "{" & vbNewLine & _
                                    Space$(4) & s_Goto & sEstado & "();" & vbNewLine & _
                                    "}" & s2NewLine
                End If
            End If
            s0 = vbNullString: s1 = vbNullString: s2 = vbNullString
            
            'Recuerda el nombre del estado en orden (para modo debug)
            sEstTxt(i) = sEstado
        End If
    Next
    For i = 1 To grafo.Nodes.count
        If LenB(strn(i)) Then s = s & strn(i)
        strn(i) = vbNullString
    Next
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Inserta las definicin de la variable ndice del FSM
    s = s & vbNewLine & " // Index variable." & vbNewLine
    If nNodos < 256 Then
        s = s & "static T_u8 " & sIndice & " = " & sIni & ";" & vbNewLine
    Else
        s = s & "static T_u16 " & sIndice & " = " & sIni & ";" & vbNewLine
    End If
    If hayEntry Then
        If bUseBitfield Then
            sEntryFlags = AddOffset(Space$(4) & "T_bit " & "flg" & sDifer, 24) & " :1;" & vbNewLine
        Else
            sEntryFlags = "static T_bit " & sPreIndice & " = 0U;" & vbNewLine
        End If
    End If
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Zona de Debug info
    If bDebug Then
        s0 = vbNewLine & "#if defined(FSM_DEBUG)" & vbNewLine & _
             Space$(4) & "static T_u8 " & sDebugTransNumber & " = (T_u8)0;" & vbNewLine & _
             Space$(4) & "static const T_char* " & sDebugStateNames & "[] = {" & vbNewLine
        For i = 1 To grafo.Nodes.count
            If LenB(sEstTxt(i)) Then
                s0 = s0 & Space$(8) & """" & sEstTxt(i) & """," & vbNewLine
            End If
        Next
        s0 = s0 & Space$(4) & "};" & vbNewLine & _
                  "#endif" & s2NewLine
        s = s & s0
        
        sAutoDebugInit = vbNewLine & barra1 & _
                    "// Debug customized macros." & vbNewLine & barra1 & _
                    "#if defined(FSM_DEBUG)" & vbNewLine
            If Not bIsParent Then
                sAutoDebugInit = sAutoDebugInit & _
                        Space$(4) & "#undef  FSM_STATE_NAME" & vbNewLine & _
                        Space$(4) & "#undef  FSM_TRANS_NUMBER" & vbNewLine & _
                        Space$(4) & "#undef  FSM_NAME" & vbNewLine
            End If
            sAutoDebugInit = sAutoDebugInit & _
                    Space$(4) & "#define FSM_STATE_NAME()   " & sDebugStateNames & "[" & sIndice & "]" & vbNewLine & _
                    Space$(4) & "#define FSM_TRANS_NUMBER() " & sDebugTransNumber & vbNewLine & _
                    Space$(4) & "#define FSM_NAME()         """ & sFuncion & """" & vbNewLine
            If bIsParent Then
                sAutoDebugInit = sAutoDebugInit & _
                        "#else" & vbNewLine & _
                        Space$(4) & "#define FSM_STATE_NAME()" & vbNewLine & _
                        Space$(4) & "#define FSM_TRANS_NUMBER()" & vbNewLine & _
                        Space$(4) & "#define FSM_NAME()" & vbNewLine
            End If
            sAutoDebugInit = sAutoDebugInit & "#endif" & vbNewLine
    End If
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Zona de macros y funciones opcionales
    s0 = DimeDatoFSM(FSM_GLOBAL_INIT, grafo) & _
         DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo) & _
         DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo) & _
         DimeDatoFSM(FSM_GLOBAL_END, grafo)
    If InStr(s0, "Is_Next_State_Illegal()") Then
        sAutoDebugInit = sAutoDebugInit & _
                            "#undef Is_Next_State_Illegal" & vbNewLine & _
                            "#define Is_Next_State_Illegal() (" & _
                            sIndice & " > " & sLastState & ")" & vbNewLine
    End If
    s0 = vbNullString
    
    'Function_Init()
    If bGenFuncInit Or Not bHistory Then
        s0 = "// Force the FSM to the initial state." & vbNewLine
        'Macro implementation
        s1 = "#define " & s_Init & " { " & sIndice & " = " & sIni & "; "
        If bDebug Then
            s2 = "#if defined(FSM_DEBUG)" & vbNewLine & _
                 Space$(4) & s1
            If hayEntry Then s2 = s2 & sPreIndice & " = 0U; "
            s2 = s2 & sDebugTransNumber & " = (T_u8)0U;" & "}" & vbNewLine & _
                    "#else" & vbNewLine & Space$(4)
        Else
            s2 = vbNullString
        End If
        s1 = s2 & s1
        If hayEntry Then s1 = s1 & sPreIndice & " = 0U; "
        s1 = s1 & "}" & vbNewLine
        If bDebug Then s1 = s1 & "#endif" & vbNewLine
        sMacFun = s0 & s1 & vbNewLine
        s1 = vbNullString: s2 = vbNullString
        'Function
        If bExportApis Then
            s1 = "void " & s_InitF
            'Function declaration
            sHeaderExp0 = s0 & _
                          s1 & ";" & s2NewLine
            'Function implementation
            sMacFun = sMacFun & s1 & vbNewLine & _
                      "{" & vbNewLine & _
                      Space$(4) & s_Init & ";" & vbNewLine & _
                      "}" & s2NewLine
        End If
    End If
    s0 = vbNullString: s1 = vbNullString: s2 = vbNullString

    'History mode
    If bHistory Then
        s0 = "// This is a history FSM." & vbNewLine & _
             "#define _" & s_InitV & "  {}" 'The children of a history FSM mustn't need to be initialized
    Else
        s0 = "// This is not a history FSM." & vbNewLine & _
             "#define _" & s_InitV & "  {" & s_InitV & "; /* Children: */ " & ChildProcVirtualInitList(grafo) & "}"
    End If
    sMacFun = sMacFun & s0 & s2NewLine

    'Function_End()
    If bGenFuncEnd Then
        s0 = "// Confirm that the FSM has reached a final state." & vbNewLine
        'Macro implementation
        sMacFun = sMacFun & s0 & "#define " & s_End & " (\" & vbNewLine & Space$(4)
        'Localiza estados finales (Implementacin)
        s1 = vbNullString
        For Each nodo In grafo.Nodes
            If EsEstadoFinal(nodo) Then
                If LenB(s1) Then s1 = s1 & " ||\" & vbNewLine & Space$(11)
                s1 = s1 & "(" & sIndice & " == i" & sDifer & "_" & UCase$(DimeDatoEstado(ESTADO_NAME, nodo)) & ")"
            End If
        Next
        If LenB(s1) = 0 Then s1 = "0"
        sMacFun = sMacFun & s1 & ")" & s2NewLine
        If bExportApis Then
            s1 = "T_u8 " & s_EndF
            'Function declaration
            sHeaderExp0 = sHeaderExp0 & s0 & _
                          s1 & ";" & s2NewLine
            'Function implementation
            sMacFun = sMacFun & s1 & vbNewLine & _
                      "{" & vbNewLine & _
                      Space$(4) & "return(" & s_End & ");" & vbNewLine & _
                      "}" & s2NewLine
        End If
    End If
    s0 = vbNullString: s1 = vbNullString
    'Function_IsIn_???()
    If LenB(sFun_IsIn_Impl) Then sMacFun = sMacFun & sFun_IsIn_Impl
    'Function_Goto_???()
    If LenB(sFun_Goto_Impl) Then sMacFun = sMacFun & sFun_Goto_Impl
    If LenB(sMacFun) Then s = s & vbNewLine & "// Macros & functions." & vbNewLine & sMacFun
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Inserta las definiciones de las funciones {Exit}
    s0 = cEnEx.DimeDefinicionExitFunc()
    If LenB(s0) Then
        s = s & vbNewLine & " // Definition of Exit_functions." & vbNewLine & _
            Indent(s0, 2) & vbNewLine
    End If
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    sAutoDefInit = s
    s = vbNullString
        
    'Inserta la funcion distribuidora
    s = s & vbNewLine & barra1 & _
            "// FSM dispatcher function to be called by the O.S." & vbNewLine & _
            barra1
    s0 = DimeDatoFSM(FSM_FUN_HEADER, grafo)
    If LenB(s0) Then s0 = PonMarcadoresCpp(AnulaMarcadoresAnsiC(s0)) & barra1
    If bIsParent Then
        sHeader = sHeader1 & barra1 & "// FSM function." & vbNewLine & barra1 & s0 & _
                  sHeader0 & vbNewLine & _
                  sHeaderExp0 & sHeaderExp1 & sHeaderExp2
        s = s & s0 & sReturnType & " " & sFuncion & "(" & sParametros & ")" & vbNewLine & "{" & vbNewLine
    Else
        sHeader = sHeaderExp0 & sHeaderExp1 & sHeaderExp2
        s = s & s0 & "static " & sReturnType & " " & sFuncion & "(" & sParametros & ")" & vbNewLine & "{" & vbNewLine
    End If
    
    'Si se necesita algna transicin encadenada se crea una variable local de control
    If hayContImm Then
        sContImm = "fsm_chainTransition" & sDifer
        sMaxLoops = "fsm_chainMaxLoops" & sDifer
        s = s & Space$(4) & "// Chain transition flag." & vbNewLine _
              & Space$(4) & "T_bit " & sContImm & ";" & vbNewLine
        If iMaxLoops > 0 Then
            s = s & Space$(4) & "T_u8 " & sMaxLoops & " = (T_u8)" & Format$(iMaxLoops) & ";" & vbNewLine
        End If
        s = s & vbNewLine
    End If
    
    'Inserta las acciones globales (antes del dispatcher) creadas por el usuario
    s0 = DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo)
    If LenB(s0) Then
        s = s & Space$(4) & "// User actions to be executed before analyse the state." & vbNewLine & _
                Indent(s0, 4) & s2NewLine
    End If

    'Zona de Debug info
    If bDebug Then
        s = s & Space$(4) & "#if defined(FSM_DEBUG)" & vbNewLine & _
                Space$(8) & sDebugTransNumber & " = (T_u8)0U;" & vbNewLine & _
                Space$(4) & "#endif" & vbNewLine
    End If

    'Si se necesita algna transicin encadenada se crea un bucle condicional
    If hayContImm Then
        nSpcContInt = 4
        s = s & Space$(nSpcContInt) & "// Chain transition loop." & vbNewLine _
              & Space$(nSpcContInt) & "do{" & vbNewLine _
              & Space$(nSpcContInt + 4) & sContImm & " = FALSE;" & vbNewLine
    Else
        nSpcContInt = 0
    End If

    'Inserta la llamada al distribuidor
    s = s & Space$(nSpcContInt + 4) & "// Next state analyser." & vbNewLine & _
            Space$(nSpcContInt + 4) & "switch(" & sIndice & "){" & vbNewLine
    
    'Detalle de cada Estado ordenados por indice
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
            sEstado = "i" & sDifer & "_" & UCase$(DimeDatoEstado(ESTADO_NAME, nodo))
            'Inicio del caso
            strn(i) = Space$(nSpcContInt + 8) & "case " & sEstado & ":" & vbNewLine

            'Carga {Entry}
            hayEntry = cEnEx.ExisteEntryAccion(i, sEntry)
            'Si hay {Entry} se debe incluir este check
            If hayEntry Then
                strn(i) = strn(i) & _
                          Space$(nSpcContInt + 12) & "// Entry check" & vbNewLine & _
                          Space$(nSpcContInt + 12) & "if(!((T_bit)" & sPreIndice & ")){" & vbNewLine & _
                          Space$(nSpcContInt + 16) & sPreIndice & " = (T_bit)1;" & vbNewLine & _
                          Space$(nSpcContInt + 16) & "// Entry actions" & vbNewLine & _
                          Indent(sEntry, nSpcContInt + 16) & vbNewLine & _
                          Space$(nSpcContInt + 12) & "}" & vbNewLine
            End If
            
            'Acciones de Moore
            s0 = DimeDatoEstado(ACTIONS_MOORE, nodo)
            If LenB(s0) Then
                strn(i) = strn(i) & Space$(nSpcContInt + 12) & "// State actions (Moore)." & vbNewLine
                strn(i) = strn(i) & Indent(s0, nSpcContInt + 12) & vbNewLine
            End If
            
            'Memoriza acciones else si existen
            s1 = DimeDatoEstado(ACTIONS_ELSE, nodo)
            If LenB(s1) Then
                sElse = "{ // Else actions." & vbNewLine & _
                        Indent(s1, nSpcContInt + 16) & vbNewLine & _
                        Space$(nSpcContInt + 12) & "}"
            Else
                sElse = vbNullString
            End If
            
            ' Analiza si existen hijos potenciales para aadir coletilla de inicializacion al salir
            parent.Reset
            sInitChilds = vbNullString
            If parent.BuscaEnlaces(s0 & vbNewLine & s1) Then
                For j = 1 To parent.DimeNumeroHijos
                    sInitChilds = sInitChilds & "_" & FileSinRutaNiExtension(parent.DimeHijo(j)) & "_Init();" & vbNewLine
                Next
                sInitChilds = Space$(nSpcContInt + 16) & "// Child Initialization." & vbNewLine & Indent(sInitChilds, nSpcContInt + 16)
            End If
            
            'Eleccion del proximo estado
            sProx = Space$(nSpcContInt + 12) & "// Next state selection." & vbNewLine & Space$(nSpcContInt + 12)
            sTrans = vbNullString
            For prio = 1 To nodo.OutLinks.count
                For Each link In nodo.OutLinks
                    If prio = Val(DimeDatoTrans(PRIORITY, link.dst)) Then
                        'Abre decisin
                        sCond = DimeDatoTrans(CONDITIONS, link.dst)
                        If LenB(Trim$(sCond)) Then
                            nEsp = IIf(prio > 1, 21, 15)
                            sTrans = sTrans & "if(" & Indent(sCond & "){", nSpcContInt + nEsp, False)
                        Else
                            If (prio < nodo.OutLinks.count) Or (LenB(sElse) > 0) Then
                                sTrans = sTrans & "if(1){"
                            Else
                                sTrans = sTrans & "{"
                            End If
                        End If
                        If nodo.OutLinks.count > 1 Then
                            sTrans = sTrans & vbTab & "// [" & DimeDatoTrans(PRIORITY, link.dst) & "]."
                        End If
                        sTrans = sTrans & vbNewLine
                        
                        'Crea si procede las acciones {Exit} heredadas
                        If cEnEx.ExistExitInThisTrans(i, prio, s0, bDesactEnEx) Then
                            s0 = Space$(nSpcContInt + 16) & "// Exit actions." & vbNewLine & _
                                 Indent(s0, nSpcContInt + 16) & vbNewLine
                        Else
                            s0 = vbNullString
                        End If
                        
                        'Inicializacion de hijos al salir
                        If Not bDesactEnEx Then
                            sTrans = sTrans & sInitChilds
                        End If
                        
                        'Aade si procede las acciones {Exit} heredadas
                        sTrans = sTrans & s0

                        'Acciones de Meally
                        s0 = DimeDatoTrans(ACTIONS_MEALY, link.dst)
                        If LenB(s0) Then
                            sTrans = sTrans & Space$(nSpcContInt + 16) & "// Transition actions (Meally)." & vbNewLine & _
                                              Indent(s0, nSpcContInt + 16) & vbNewLine
                        End If

                        'Apunta el prximo estado
                        If Not link.dst.OutLinks(1).dst Is nodo Then
                            sNext = "i" & sDifer & "_" & UCase$(DimeDatoEstado(ESTADO_NAME, link.dst.OutLinks(1).dst))
                            sTrans = sTrans & Space$(nSpcContInt + 16) & "// Pointing to the next state." & vbNewLine & _
                                              Space$(nSpcContInt + 16) & sIndice & " = " & sNext & ";" & vbNewLine
                        End If
                        'Zona de Debug info
                        If bDebug Then
                            sTrans = sTrans & _
                                    Space$(nSpcContInt + 16) & "#if defined(FSM_DEBUG)" & vbNewLine & _
                                    Space$(nSpcContInt + 20) & sDebugTransNumber & " = (T_u8)" & DimeDatoTrans(PRIORITY, link.dst) & ";" & vbNewLine & _
                                    Space$(nSpcContInt + 16) & "#endif" & vbNewLine
                        End If

                        'Si hay {Entry} se debe incluir esto
                        If hayEntry And Not bDesactEnEx Then
                            sTrans = sTrans & _
                                     Space$(nSpcContInt + 16) & "// Reset entry flag" & vbNewLine & _
                                     Space$(nSpcContInt + 16) & sPreIndice & " = 0U;" & vbNewLine
                        End If
                        
                        'Si se necesita encadenar esta transicin se confirma el flag
                        If hayContImm Then
                            If cContImm.ExistInThisTrans(i, prio) Then
                                sTrans = sTrans & _
                                         Space$(nSpcContInt + 16) & "// Chain transition." & vbNewLine & _
                                         Space$(nSpcContInt + 16) & sContImm & " = TRUE;" & vbNewLine
                            End If
                        End If

                        'Cierra decisin
                        sTrans = sTrans & Space$(nSpcContInt + 12) & "}else "
                        Exit For
                    End If
                Next
            Next
            'Aade transiciones del estado si existen
            If LenB(sTrans) Then
                If LenB(sElse) = 0 Then
                    strn(i) = strn(i) & sProx & Left$(sTrans, Len(sTrans) - 5) & vbNewLine
                Else
                    strn(i) = strn(i) & sProx & sTrans & sElse & vbNewLine
                End If
            Else
                If LenB(sElse) Then strn(i) = strn(i) & Space$(nSpcContInt + 12) & sElse & vbNewLine
            End If
            
            'Final de la funcion
            strn(i) = strn(i) & Space$(nSpcContInt + 8) & "break;" & vbNewLine
        End If
    Next
    For i = 1 To grafo.Nodes.count
        If LenB(strn(i)) Then s = s & strn(i)
    Next
    
    'Add default case if it's necessary
    sDefault = DimeDatoFSM(FSM_GLOBAL_DEFAULT, grafo)
    If LenB(sDefault) Then
        s = s & Space$(nSpcContInt + 8) & "default:" & vbNewLine & _
                Space$(nSpcContInt + 12) & "// State index error trap (MISRA requiremment)." & vbNewLine & _
                Indent(sDefault, nSpcContInt + 12) & vbNewLine & _
                Space$(nSpcContInt + 8) & "break;" & vbNewLine
    End If
    s = s & Space$(nSpcContInt + 4) & "}" & vbNewLine
    
    'Si se necesita algna transicin encadenada se cierra un bucle condicional
    If hayContImm Then
        If iMaxLoops > 0 Then
            s = s & Space$(nSpcContInt + 4) & sMaxLoops & "--;" & vbNewLine
            s = s & Space$(nSpcContInt) & "}while(" & sContImm & " && (" & sMaxLoops & " > (T_u8)0));" & vbNewLine
        Else
            s = s & Space$(nSpcContInt) & "}while(" & sContImm & ");" & vbNewLine
        End If
    End If
    
    'Inserta las acciones globales (detrs del dispatcher) creadas por el usuario
    s0 = DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo)
    If LenB(s0) Then
        s = s & vbNewLine & Space$(4) & "// User actions to be executed after analyse the state." & vbNewLine & _
                Indent(s0, 4) & vbNewLine
    End If
    
    'Termina la funcion distribuidora
    s = s & "}" & s2NewLine
    
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Inserta las implementaciones de las funciones {Exit}
    s0 = cEnEx.DimeImplementacionExitFunc()
    If LenB(s0) Then
        s = s & vbNewLine & " // Implementation of Exit_functions." & vbNewLine & _
            s0 & vbNewLine
    End If
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    
    sDispatcher = s
    s = vbNullString
    
    'Inserta las acciones globales finales (fuera de la funcin) creadas por el usuario
    s0 = DimeDatoFSM(FSM_GLOBAL_END, grafo)
    If Len(s0) Then
        s = s0 & vbNewLine
    End If
    
    If bTextBoxesInCode Then
        s = s & barra1 & "// Diagram comments (Start)." & vbNewLine & barra2 & _
                PrintTextBoxesInCode(grafo) & _
                barra2 & "// Diagram comments (End)." & vbNewLine & barra1 & vbNewLine
    End If
  
    sTail = s

    C_CodeGen_HierarchicalSwitchCase = True
End Function
