VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsContinueImmediately"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type tipoNodo
    transIsContImm() As Boolean
End Type
Private dat() As tipoNodo
Private nDat As Long


'Captura todos "ContinueImmediately"
Public Sub Captura(grafo As AddFlow, bHayContImm As Boolean, iMaxLoops As Long)
Dim nodo As afNode
Dim link As afLink
Dim i As Long
Dim j As Long
    
    bHayContImm = False
    
    'Rastrea el grafo
    ReDim dat(1 To grafo.Nodes.count) As tipoNodo
    nDat = 0
    For Each nodo In grafo.Nodes
        ' Captura nodos de estado (en orden)
        If EsEstado(nodo) Then
            nDat = nDat + 1
            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
            With dat(i)
                ' Captura todas las transiciones de este nodo (en orden)
                If nodo.OutLinks.count > 0 Then
                    ReDim .transIsContImm(1 To nodo.OutLinks.count) As Boolean
                    For Each link In nodo.OutLinks
                        j = Val(DimeDatoTrans(PRIORITY, link.dst))
                        .transIsContImm(j) = DimeDatoTrans(CONTINUE_IMMEDIATELY, link.dst) = "Y"
                        If .transIsContImm(j) Then
                            bHayContImm = True
                        End If
                    Next
                End If
            End With
        End If
    Next
    
    'Carga los valores limites para el bucle
    If bHayContImm Then
        iMaxLoops = Val(DimeDatoFSM(FSM_MAX_LOOPS, grafo))
        If iMaxLoops > 255 Then iMaxLoops = 255
        If iMaxLoops < 0 Then iMaxLoops = 0
        If iMaxLoops = 1 Then bHayContImm = False
    Else
        iMaxLoops = 0
    End If
   
    'Elimina los huecos de la lista manteniendo el orden
    ReDim Preserve dat(1 To nDat) As tipoNodo
End Sub


'Confirma si existe "ContinueImmediately" y lo devuelve en "valor"
Public Function ExistInThisTrans(indEstado As Long, priTransi As Long) As Boolean
    ExistInThisTrans = dat(indEstado).transIsContImm(priTransi)
End Function
