VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsEntryExit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type tipoTransicion
    nombre As String
    desactExEn As Boolean
    transExitAccion As String
End Type

Private Type tipoFuncion
    existe As Boolean
    defi As String      'Definicin de la funcion
    imple As String     'Implementacin de la funcion
End Type

Private Type tipoAccion
    count As Long           'N de {Entry} o {Exit} activas
    txt As String           'Contenido de {Entry} o {Exit}
    func As tipoFuncion
End Type

Private Type tipoNodo
    nombre As String
    entry_txt As String
    exit As tipoAccion
    trans() As tipoTransicion
    nTrans As Long       'N Total de transiciones de un estado
End Type
Private d() As tipoNodo
Private nDat As Long

Private errorCounter As Long

Private bHayEntry As Boolean
Private bHayExit As Boolean

'Procesa todas las acciones Entry y Exit y devuleve el
'n de inconsistencias encontrado
Public Function ProcesarEntryExit(grafo As AddFlow, hayEntry As Boolean, Optional hayExit As Boolean) As Long
    bHayExit = False
    bHayEntry = False
    CapturaEntryExit grafo
    ProcesaExit
    hayExit = bHayExit
    hayEntry = bHayEntry
ProcesarEntryExit = errorCounter
End Function


'Captura ENTRY_EXIT
Private Sub CapturaEntryExit(grafo As AddFlow)
Dim nodo As afNode
Dim link As afLink
Dim i As Long
Dim j As Long
    
    'Rastrea el grafo
    ReDim d(1 To grafo.Nodes.count) As tipoNodo
    nDat = 0
    For Each nodo In grafo.Nodes
        ' Captura nodos de estado (en orden)
        If EsEstado(nodo) Then
            nDat = nDat + 1
            i = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
            With d(i)
                .nombre = DimeDatoEstado(ESTADO_NAME, nodo)
                .entry_txt = DimeDatoEstado(ACTIONS_ENTRY, nodo)
                If LenB(.entry_txt) > 0 Then bHayEntry = True
                .exit.txt = DimeDatoEstado(ACTIONS_EXIT, nodo)
                If LenB(.exit.txt) > 0 Then bHayExit = True

                ' Captura todas las transiciones de este nodo (en orden)
                .nTrans = nodo.OutLinks.count
                If .nTrans > 0 Then
                    ReDim .trans(1 To .nTrans) As tipoTransicion
                    For Each link In nodo.OutLinks
                        j = Val(DimeDatoTrans(PRIORITY, link.dst))
                        .trans(j).nombre = DimeDatoEstado(ESTADO_NAME, link.dst.OutLinks(1).dst)
                        
                        'Si es el mismo verifica si se ha de desactivar el forzar {Exit}&{Entry}
                        .trans(j).desactExEn = False
                        If nodo Is link.dst.OutLinks(1).dst Then
                            If DimeDatoTrans(ENTRY_EXIT_SELF_TRANS, link.dst) = "N" Then
                                .trans(j).desactExEn = True
                            End If
                        End If
                    Next
                End If
                
                'Memoriza el numero de {exit}
                If LenB(.exit.txt) > 0 Then
                    .exit.count = .nTrans
                    'Chequea inconsistencias de {exit} huerfanos
                    If .exit.count = 0 Then
                        MsgBox "The ""Exit action"" of the node: " & .nombre & vbNewLine & _
                               "node hasn 't Exit transitions were transfer it.", _
                               vbCritical
                        errorCounter = errorCounter + 1
                    End If
                End If
           End With
       End If
   Next
    'Elimina los huecos del la lista manteniendo el orden
    ReDim Preserve d(1 To nDat) As tipoNodo
End Sub

'Se buscan todas {exit} y se pesan:
' 1) si(ligeras)---> se implementan directamente
' 2) si(pesadas)---> se crea funcin de implementacin y se emplea una llamada
Private Sub ProcesaExit()
Dim io As Long   'Indice de origen
Dim it As Long   'Prioridad de transiciones de destino
Dim sInsert As String
    'Rastrea el grafo
    For io = 1 To nDat
    With d(io)
        If .exit.count > 0 Then
            If esPesada(.exit) Then
                'Ha de crear funcin {..._OnExit()}
                .exit.func.existe = True
                .exit.func.defi = "static void " & .nombre & "_OnExit(void);"
                .exit.func.imple = "static void " & .nombre & "_OnExit(void)" & vbNewLine & _
                                   "{" & vbNewLine & _
                                   Indent(.exit.txt, 4) & vbNewLine & _
                                   "}"
                'Insertara en cada transicion una llamada a la funcin  {..._OnExit()}
                sInsert = .nombre & "_OnExit();"
            Else
                .exit.func.existe = False
                'Copiar el cdigo directamente en todas transiciones
                sInsert = .exit.txt
            End If
            'Inserta en cada transicion
            For it = 1 To .nTrans
                .trans(it).transExitAccion = sInsert
            Next
       End If
    End With
    Next
End Sub

'Conociendo el nmero #a de {aciones}, decidiremos de esta manera:
' 1) si(#a == 1)---> es ligera
' 2) si(#a > 1) ---> contamos nmero #b de ";"
'   2.1) si(#b <= 2) ---> es ligera
'   2.2) si(#b > 2) ---> es pesada
Private Function esPesada(accion As tipoAccion) As Boolean
Dim i As Long
Dim n As Long
    If accion.count > 1 Then
        i = 0
        n = -1
        Do
            n = n + 1
            i = InStr(i + 1, accion.txt, ";")
        Loop While i > 0
        esPesada = (n > 2)
    Else
        esPesada = False
    End If
End Function

'Devuelve un listado de definiciones de Funciones {exit}
Public Function DimeDefinicionExitFunc() As String
Dim i As Long   'Indice de origen
Dim sRes As String

    'Rastrea el grafo an busca de {exit}
    For i = 1 To nDat
    With d(i)
        'Si hay {exit}
        If .exit.count > 0 Then
            'Si hay funcin {..._OnExit()}
            If .exit.func.existe Then
                 sRes = sRes + .exit.func.defi & vbNewLine
            End If
        End If
    End With
    Next

DimeDefinicionExitFunc = sRes
End Function

'Devuelve un listado de implementaciones de Funciones {exit}
Public Function DimeImplementacionExitFunc() As String
Dim i As Long   'Indice de origen
Dim sRes As String

    'Rastrea el grafo an busca de {exit}
    For i = 1 To nDat
    With d(i)
        'Si hay {exit}
        If .exit.count > 0 Then
            'Si hay funcin {..._OnExit()}
            If .exit.func.existe Then
                 sRes = sRes + .exit.func.imple & vbNewLine
            End If
        End If
    End With
    Next

    DimeImplementacionExitFunc = sRes
End Function

'Confirma si existe {entry} y lo devuelve en "valor"
Public Function ExisteEntryAccion(indEstado As Long, valor As String) As Boolean
    valor = d(indEstado).entry_txt
    ExisteEntryAccion = LenB(valor)
End Function

'Devuelve la {exit} accion, si existe
Public Function ExitAction(indEstado As Long) As String
    ExitAction = d(indEstado).exit.txt
End Function

'Confirma si existe {exit} y lo devuelve en "valor"
Public Function ExistExitInThisTrans(indEstado As Long, priTransi As Long, valor As String, bDesactExEn As Boolean) As Boolean
    valor = d(indEstado).trans(priTransi).transExitAccion
    bDesactExEn = d(indEstado).trans(priTransi).desactExEn
    ExistExitInThisTrans = (LenB(valor) > 0) And (Not bDesactExEn)
End Function

Public Property Get NumNodos() As Long
    NumNodos = nDat
End Property

'Devuelve la {exit} accion, si existe
Public Function StateName(index As Long) As String
    StateName = d(index).nombre
End Function

