Attribute VB_Name = "modFont"
Option Explicit

Private enhancegr As New clsGraphicEnhancement

Public Sub AmpliaFont(frm As frmDoc)

Dim nodo As afNode
    With frm.AddFlow1
        If .readOnly = True Then Exit Sub
        
        .Repaint = False
        If EsComentario(.SelectedNode) Then
            frm.Text1_LostFocus
            Set nodo = .SelectedNode
            .SetChangedFlag True
            If nodo.Font.size < SIZE_FONT_MAX Then
                nodo.Font.size = nodo.Font.size + 1
                Call enhancegr.AdjustSize(nodo)
            End If
        Else
            'Cambia el tamao
            If .Font.size < SIZE_FONT_MAX Then
                .SetChangedFlag True
                .Font.size = .Font.size + 1
            
                'Busca todos los nodos
                For Each nodo In .Nodes
                    nodo.Font.size = .Font.size
                    'Reajusta el tamao del nodo
                    Call enhancegr.AdjustSize(nodo)
                Next
            End If
        End If
        .Repaint = True
    End With
End Sub
Public Sub ReduceFont(frm As frmDoc)
Dim nodo As afNode
    With frm.AddFlow1
        If .readOnly = True Then Exit Sub
        
        .Repaint = False
        If EsComentario(.SelectedNode) Then
            frm.Text1_LostFocus
            Set nodo = .SelectedNode
            .SetChangedFlag True
            If nodo.Font.size > SIZE_FONT_MIN Then
                nodo.Font.size = nodo.Font.size - 1
                Call enhancegr.AdjustSize(nodo)
            End If
        Else
            'Cambia el tamao
            If .Font.size > SIZE_FONT_MIN Then
                .SetChangedFlag True
                .Font.size = .Font.size - 1
            
                'Busca todos los nodos
                For Each nodo In .Nodes
                    nodo.Font.size = .Font.size
                    'Reajusta el tamao del nodo
                    Call enhancegr.AdjustSize(nodo)
                Next
            End If
        End If
        .Repaint = True
    End With
End Sub
Public Sub AjustaFontText(txt As TextBox)
Dim ordenValida As Boolean

    With mainFrm.dlgCommonDialog
        'Prepara pantalla de dialogo
        .fontName = txt.fontName
        .fontSize = txt.fontSize
        .FontBold = txt.FontBold
        .FontItalic = txt.FontItalic
        .FontUnderline = txt.FontUnderline
        .FontStrikethru = txt.FontStrikethru
        .Color = txt.ForeColor
        .Flags = cdlCFScreenFonts Or cdlCFEffects
        ordenValida = True
        .CancelError = True
        On Error GoTo ControlError   ' Activa la rutina de control de errores.
        .ShowFont
        On Error GoTo 0   ' Desactiva la deteccin de errores.
        
        'Actualiza nueva configuracin al grafo config
        If ordenValida Then
            txt.fontName = .fontName
            txt.fontSize = .fontSize
            txt.FontBold = .FontBold
            txt.FontItalic = .FontItalic
            txt.FontUnderline = .FontUnderline
            txt.FontStrikethru = .FontStrikethru
            txt.ForeColor = .Color
        End If
    End With
Exit Sub   ' Salir para evitar el controlador.
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case cdlCancel   'se Cancelo la orden
            ordenValida = False
        Case Else
            Error Err.Number
    End Select
    Resume Next  ' Continuar ejecucin en la lnea siguiente a la que caus el error.
End Sub
Public Sub AjustaFont(frm As frmDoc, fixedOnly As Boolean)
Dim grafo As AddFlow
Dim nodo As afNode
Dim ordenValida As Boolean
Dim processingAComment As Boolean

    Set grafo = frm.AddFlow1

    If grafo.readOnly Then Exit Sub

    processingAComment = EsComentario(grafo.SelectedNode)
    
    With mainFrm.dlgCommonDialog
        'Prepara pantalla de dialogo
        If processingAComment Then
            frm.Text1_LostFocus
            Set nodo = grafo.SelectedNode
            .fontName = nodo.Font.Name
            .fontSize = nodo.Font.size
            .FontBold = nodo.Font.Bold
            .FontItalic = nodo.Font.Italic
            .FontUnderline = nodo.Font.Underline
            .FontStrikethru = nodo.Font.Strikethrough
            .Color = nodo.ForeColor
            .Flags = cdlCFScreenFonts Or cdlCFEffects
        Else
            .fontName = grafo.Font.Name
            .fontSize = grafo.Font.size
            .FontBold = grafo.Font.Bold
            .FontItalic = grafo.Font.Italic
            .FontUnderline = grafo.Font.Underline
            .FontStrikethru = grafo.Font.Strikethrough
            .Flags = cdlCFScreenFonts
            If fixedOnly Then .Flags = .Flags Or cdlCFFixedPitchOnly
        End If

        ordenValida = True
        .CancelError = True          ' Permite el uso de Cancel para generar error
        On Error GoTo ControlError   ' Activa la rutina de control de errores.
        .ShowFont
        On Error GoTo 0   ' Desactiva la deteccin de errores.
        
        'Actualiza nueva configuracin al grafo config
        If ordenValida Then
            grafo.SetChangedFlag True
            If processingAComment Then
                nodo.Font.Name = .fontName
                nodo.Font.size = .fontSize
                nodo.Font.Bold = .FontBold
                nodo.Font.Italic = .FontItalic
                nodo.Font.Underline = .FontUnderline
                nodo.Font.Strikethrough = .FontStrikethru
                nodo.ForeColor = .Color
                'Reajusta el tamao del nodo
                Call enhancegr.AdjustSize(nodo)
            Else
                grafo.Font.Name = .fontName
                grafo.Font.size = .fontSize
                grafo.Font.Bold = .FontBold
                grafo.Font.Italic = .FontItalic
                grafo.Font.Underline = .FontUnderline
                grafo.Font.Strikethrough = .FontStrikethru
                grafo.Repaint = False
                'Actualiza todos los nodos
                
                For Each nodo In grafo.Nodes
                    nodo.Font.Name = grafo.Font.Name
                    nodo.Font.size = grafo.Font.size
                    nodo.Font.Bold = grafo.Font.Bold
                    nodo.Font.Italic = grafo.Font.Italic
                    nodo.Font.Underline = grafo.Font.Underline
                    nodo.Font.Strikethrough = grafo.Font.Strikethrough
                    'Reajusta el tamao del nodo
                    Call enhancegr.AdjustSize(nodo)
                Next
                grafo.Repaint = True
            End If
        End If
    End With

Exit Sub   ' Salir para evitar el controlador.
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case cdlCancel   'se Cancelo la orden
            ordenValida = False
        Case Else
            Error Err.Number
    End Select
    Resume Next  ' Continuar ejecucin en la lnea siguiente a la que caus el error.
End Sub

