Attribute VB_Name = "modNodoTransicion"
Option Explicit

Private enhancegr           As New clsGraphicEnhancement

Public Enum enumParamTrans
    PRIORITY
    CONDITIONS
    ACTIONS_MEALY
    ENTRY_EXIT_SELF_TRANS
    MUST_BE_LAST
    CONTINUE_IMMEDIATELY
End Enum

Public Function EsTransicion(nodo As afNode) As Boolean
    EsTransicion = nodo.UserData And NODO_TRANSICION
End Function

'Extrae la informacin del nodo de transicion
Public Function DimeDatoTrans(posicion As enumParamTrans, nodo As afNode) As String
    DimeDatoTrans = ExtraeCampo(nodo.Tag, posicion)
End Function
'Calcula una nueva prioridad (la ltima+1) para un nuevo link
Private Function DameNuevaPrioridad(nodo As afNode) As String
Dim link As afLink
Dim maxPri As Long
Dim pri As Long

    'Busca la prioridad ms alta existente
    If nodo.InLinks.count > 0 Then
        For Each link In nodo.InLinks(1).org.OutLinks
            If EsTransicion(link.dst) And Not (link.dst Is nodo) Then
                pri = Val(DimeDatoTrans(PRIORITY, link.dst))
                If pri > maxPri Then
                    maxPri = pri
                End If
            End If
        Next
    Else
        'Es un nodo aislado
        maxPri = 0
    End If
    DameNuevaPrioridad = Format$(maxPri + 1)
End Function


Public Sub Configura_Nodo_Transicion(prioridad As String, condicion As String, _
                                     accion As String, sEntryExitSelfTr As String, _
                                     sMustBeLast As String, _
                                     sContinueImmediately As String, _
                                     nodo As afNode)
Dim centro As tipoCoordenada
    
    'Memoriza el centro del nodo de transicin
    centro.y = nodo.top + nodo.Height / 2
    centro.x = nodo.Left + nodo.Width / 2

    nodo.UserData = NODO_TRANSICION
    If nodo.InLinks(1).org.OutLinks.count > 1 Then
        If sMustBeLast = "Y" Then
            nodo.Text = "{" & prioridad & "}"
        Else
            nodo.Text = "[" & prioridad & "]"
        End If
    Else
        nodo.Text = vbNullString
    End If
    If LenB(condicion) > 0 Then
        nodo.Text = nodo.Text & FiterAndMakeTxtState(condicion, 0)
    ElseIf LenB(nodo.Text) > 0 Then
        nodo.Text = nodo.Text & vbNewLine
    End If
    If LenB(accion) > 0 Then
        nodo.Text = nodo.Text & "/" & FiterAndMakeTxtState(accion, 0)
    End If

    If sEntryExitSelfTr = "N" Then
        nodo.OutLinks(1).DrawColor = DARK_GREEN
        nodo.InLinks(1).DrawColor = DARK_GREEN
        nodo.OutLinks(1).DrawStyle = afDot
        nodo.InLinks(1).DrawStyle = afDot
    Else
        nodo.OutLinks(1).DrawColor = vbBlue
        nodo.InLinks(1).DrawColor = vbBlue
        nodo.OutLinks(1).DrawStyle = afSolid
        nodo.InLinks(1).DrawStyle = afSolid
    End If
    
    If sContinueImmediately = "Y" Then
        nodo.InLinks(1).DrawColor = DARK_RED
        nodo.OutLinks(1).DrawColor = DARK_RED
        nodo.OutLinks(1).ArrowDst = afEmptyArrow15
    Else
        nodo.OutLinks(1).ArrowDst = afFilledArrow15
    End If
    
    If LenB(nodo.Text) > 0 Then
        nodo.DrawStyle = afTransparent
    Else
        nodo.DrawStyle = afSolid
        nodo.Width = 1
        nodo.Height = 1
    End If

    nodo.Tag = prioridad & SEPARADOR & _
               condicion & SEPARADOR & _
               accion & SEPARADOR & _
               sEntryExitSelfTr & SEPARADOR & _
               sMustBeLast & SEPARADOR & _
               sContinueImmediately & SEPARADOR

    'Reajusta el tamao del nodo
    Call enhancegr.AdjustSize(nodo)

    'Limita el tamao mnimo de los nodos
    Call enhancegr.LimitMinimSize(nodo)

    'Centra de nuevo el nodo
    centro.x = centro.x - nodo.Width / 2
    centro.y = centro.y - nodo.Height / 2
    nodo.Left = IIf(centro.x > 0, centro.x, 1)
    nodo.top = IIf(centro.y > 0, centro.y, 1)
End Sub
'Normaliza las prioridades de todas las transiciones de un nodo de estado dado
'Tiene prioridad el nodo seleccionado
Public Sub Normaliza_Prioridades(nodo As afNode, selNode As afNode)
Dim link As afLink
Dim pri As Long
Dim minPri As Long
Dim priNodoSelecc As Long
Dim i As Long
Dim nodoPri As afNode
        
    If selNode Is Nothing Then
        priNodoSelecc = MAX_LONG
    Else
        priNodoSelecc = Val(DimeDatoTrans(PRIORITY, selNode))
    End If
    
    If nodo.OutLinks.count Then
        
        'Seek if exist a predeterminated last node
        For Each link In nodo.OutLinks
            If EsTransicion(link.dst) Then
                If DimeDatoTrans(MUST_BE_LAST, link.dst) = "Y" Then
                    Configura_Nodo_Transicion Format$(MAX_TRANS_PRIORITY + 1), _
                              DimeDatoTrans(CONDITIONS, link.dst), _
                              DimeDatoTrans(ACTIONS_MEALY, link.dst), _
                              DimeDatoTrans(ENTRY_EXIT_SELF_TRANS, link.dst), _
                              "Y", _
                              DimeDatoTrans(CONTINUE_IMMEDIATELY, link.dst), _
                              link.dst
                End If
            End If
        Next
        
        i = 0
        Do
            minPri = MAX_LONG
            'Busca la prioridad ms baja existente
            For Each link In nodo.OutLinks
                If EsTransicion(link.dst) Then
                    If (link.dst.UserData And NODO_OFF) = 0 Then
                        pri = Val(DimeDatoTrans(PRIORITY, link.dst))
                        If pri < minPri Then
                            minPri = pri
                            Set nodoPri = link.dst
                        End If
                    End If
                End If
            Next
            
            'Comprueba que se haya encontrado algn elemento
            If minPri = MAX_LONG Then Exit Do
            'Da preferencia al nodo de transicin seleccionado
            If minPri = priNodoSelecc Then
                If ((selNode.UserData And NODO_OFF) = 0) And (Not nodoPri Is selNode) Then
                    Set nodoPri = selNode
                End If
            End If
            'Asigna la prioridad correspondiente
            i = i + 1
            Configura_Nodo_Transicion Format$(i), _
                                      DimeDatoTrans(CONDITIONS, nodoPri), _
                                      DimeDatoTrans(ACTIONS_MEALY, nodoPri), _
                                      DimeDatoTrans(ENTRY_EXIT_SELF_TRANS, nodoPri), _
                                      DimeDatoTrans(MUST_BE_LAST, nodoPri), _
                                      DimeDatoTrans(CONTINUE_IMMEDIATELY, nodoPri), _
                                      nodoPri
            nodoPri.UserData = nodoPri.UserData Or NODO_OFF      'Elimina de la coleccin
        Loop
            
        'Restaura el indicador Tag
        For Each link In nodo.OutLinks
            If link.dst.UserData And NODO_OFF Then
                link.dst.UserData = (link.dst.UserData And (Not NODO_OFF))
            End If
        Next
    End If
End Sub



'Crea una decisin vaca en medio de dos nodos
Public Sub CreaDecisionIntermedia()
Dim org As tipoCoordenada
Dim dst As tipoCoordenada
Dim med As tipoCoordenada
Dim nodo As afNode
Dim grafo As AddFlow
    
    Set grafo = mainFrm.ActiveForm.AddFlow1
    With grafo
        org.y = .SelectedLink.org.top + .SelectedLink.org.Height / 2
        org.x = .SelectedLink.org.Left + .SelectedLink.org.Width / 2
        dst.y = .SelectedLink.dst.top + .SelectedLink.dst.Height / 2
        dst.x = .SelectedLink.dst.Left + .SelectedLink.dst.Width / 2
        med.x = (org.x + dst.x) / 2
        med.y = (org.y + dst.y) / 2
        
        'Aade el nodo de tipo Decisin
        Set nodo = .Nodes.Add(med.x, med.y, 1, 1)
        nodo.ForeColor = 0
        nodo.FillColor = &HFFFFC0
        nodo.Shape = afProcess
        nodo.Transparent = True
        nodo.ZOrder = False

        'Aade los correspondientes links entre nodos
        .ArrowDst = afNoArrow
        .SelectedLink.org.OutLinks.Add nodo
        .ArrowDst = afFilledArrow15
        .SelectedLink.dst.InLinks.Add nodo

        nodo.InLinks(1).ZOrder = True
        nodo.OutLinks(1).ZOrder = True
        .DeleteSel

'       'Rellena el nuevo nodo
        Configura_Nodo_Transicion DameNuevaPrioridad(nodo), vbNullString, vbNullString, "Y", "N", "N", nodo
        
        'Fuerza que aparezcan las prioridades
        Normaliza_Prioridades nodo.InLinks(1).org, nodo
    End With
End Sub



'Busca subcadena en todas las transiciones
Public Function RastreaSubcadenaEnTransiciones(subCadena As String, sAReemplazar As String, caseSensitive As Boolean) As Boolean
Dim nodo As afNode
Dim grafo As AddFlow
    Set grafo = mainFrm.ActiveForm.AddFlow1
    For Each nodo In grafo.Nodes
        If EsTransicion(nodo) Then
            grafo.SelectedNode = nodo
            If frmPropTransicion.Buscar(subCadena, sAReemplazar, caseSensitive) = False Then
                Exit For
            End If
        End If
    Next
    RastreaSubcadenaEnTransiciones = True
End Function

