Attribute VB_Name = "modStrings"
Option Explicit

Private Function RemoveHideComent(s As String) As String
Dim activeFrmDoc As frmDoc
    Set activeFrmDoc = mainFrm.ActiveForm
    'Oculta las lineas de comentarios puros si esta activado la opcin correspondiente
    If activeFrmDoc.mnuHideComments.Checked Then
        If InStr(LTrim$(s), "//") = 1 Then
            RemoveHideComent = vbNullString
            Exit Function
        End If
    End If

    'Tambin oculta todas las lneas que contienen "//HIDE_LINE"
    If InStr(LTrim$(s), "//HIDE_LINE") Then
        RemoveHideComent = vbNullString
        Exit Function
    End If
    RemoveHideComent = s

End Function

' Prepare the state text to be displayed
Public Function FiterAndMakeTxtState(origen As String, sangrado As Integer) As String
Dim i As Long
Dim s As String
Dim ln As String
Dim lng As Long

    lng = Len(origen)
    FiterAndMakeTxtState = vbNullString
    If lng Then
        For i = 1 To lng
            s = Mid$(origen, i, 1)
    
            Select Case s
                Case vbCr
                    ln = Space$(sangrado) & ln & vbNewLine
                    FiterAndMakeTxtState = FiterAndMakeTxtState & RemoveHideComent(ln)
                    ln = vbNullString
                Case vbLf
'                Case "&"
'                    ln = ln & "&&"
                Case Else
                    ln = ln & s
            End Select
        Next
        ln = Space$(sangrado) & ln & vbNewLine
        FiterAndMakeTxtState = FiterAndMakeTxtState & RemoveHideComent(ln)
    End If
End Function

'Retorna indicacion de error
Public Function EliminarPath(ByRef frase As String, palabra As String, sRet As String) As Boolean
Dim posMarca As Integer
Dim posComodin As Integer
Dim iniRuta As Integer
Dim s As String
    
    EliminarPath = False
    posComodin = InStr(palabra, "*")
    If (posComodin > 0) Then
        palabra = Mid$(palabra, 1, posComodin - 1) & Mid$(palabra, posComodin + 1)
    End If
    posMarca = InStr(UCase$(frase), palabra)
    If posMarca Then
        If (posComodin > 0) Then
            posComodin = InStr(posMarca, UCase$(frase), " ")
            If (posComodin = 0) Then
                posComodin = Len(frase) + 1
            End If
        End If
        iniRuta = posMarca + Len(palabra)
        sRet = Trim$(Mid$(frase, iniRuta, posComodin - iniRuta))
        If Right$(sRet, 1) = "\" Then sRet = Left$(sRet, Len(sRet) - 1)
        If LenB(Dir(sRet, vbDirectory)) = 0 Then
            s = palabra & sRet
            sRet = vbNullString 'Antes de LogError (pues es un alias de pathError)
            LogError "Path error [" & s & "]"
            EliminarPath = True
        End If
        frase = Trim$(Left$(frase, posMarca - 1) & Mid$(frase, posComodin + 1))
    Else
        sRet = vbNullString
    End If
End Function

Public Function SeElimino(ByRef frase As String, palabra As String) As Boolean
Dim posMarca As Integer
   
    posMarca = InStr(UCase$(frase), palabra)
    If posMarca Then
        frase = Trim$(Left$(frase, posMarca - 1) & Mid$(frase, posMarca + Len(palabra)))
        SeElimino = True
    Else
        SeElimino = False
    End If
End Function


Public Function BuscarEnTextBox(txtB As TextBox, sBusca As String, caseSensitive As Boolean, Optional desde As Long = 1) As Boolean
Dim where As Long
    If caseSensitive Then
        where = InStr(desde, txtB.Text, sBusca)     ' Busca la cadena en el texto.
    Else
        where = InStr(desde, LCase$(txtB.Text), LCase$(sBusca))   ' Busca la cadena en el texto.
    End If
    If where Then
        ' Si se encuentra,
        txtB.SelStart = where - 1   ' se establece el inicio de la seleccin
        txtB.SelLength = Len(sBusca)   ' y se establece la longitud para seleccionar.
        BuscarEnTextBox = True
    Else
        BuscarEnTextBox = False
    End If
End Function


'Extrae todos los campos de una cadena registro
Public Sub ExtraeTodosCampos(destino() As String, origen As String)
Dim i As Long
Dim f As Long
Dim contCampos As Long
Dim maxCampos As Long

    'Aisla los campos
    maxCampos = UBound(destino)
    contCampos = LBound(destino)
    i = 1
    Do
        f = InStr(i, origen, SEPARADOR)
        If f Then
            destino(contCampos) = Mid$(origen, i, f - i)
            i = f + LEN_SEPARADOR
        Else
            destino(contCampos) = vbNullString
        End If
        contCampos = contCampos + 1
    Loop While contCampos <= maxCampos
End Sub
'Extrae un campo de una cadena registro
Public Function ExtraeCampo(sOrigen As String, campo As Long) As String
Dim i As Long
Dim j As Long
Dim contCampos As Long

    'Busca el campo si existe
    i = 1
    contCampos = 0
    Do
        j = InStr(i, sOrigen, SEPARADOR)
        If j Then
            If campo = contCampos Then
                ExtraeCampo = Mid$(sOrigen, i, j - i)
                Exit Function
            End If
            i = j + LEN_SEPARADOR
        Else
            ExtraeCampo = vbNullString
            Exit Function
        End If
        contCampos = contCampos + 1
    Loop
End Function

'Pone marcadores C++
Public Function PonMarcadoresCpp(origen As String) As String
Dim i As Long
Dim ch As String
Dim line As String
Dim s As String
    
    For i = 1 To Len(origen)
        ch = Mid$(origen, i, 1)
        Select Case ch
            Case vbCr
                s = s & "// " & line & vbNewLine
                line = vbNullString
                ch = vbNullString
            Case vbLf
                ch = vbNullString
            Case Else
        End Select
        line = line & ch
    Next
    PonMarcadoresCpp = s & "// " & line & vbNewLine
End Function

'Anula marcadores Ansi-C internos y pone entre comentarios
Public Function AnulaMarcadoresAnsiC(origen As String) As String
Dim i As Long
Dim ch As String
Dim line As String
Dim s As String
Dim bProbStart As Boolean
Dim bProbEnd As Boolean

    If InStr(origen, "/*") = 0 And InStr(origen, "*/") = 0 Then
        AnulaMarcadoresAnsiC = origen
    Else
        For i = 1 To Len(origen)
            ch = Mid$(origen, i, 1)
            If bProbStart Then
                bProbStart = False
                If ch = "*" Then line = line & " "
            End If
            If bProbEnd Then
                bProbEnd = False
                If ch = "/" Then line = line & " "
            End If
    
            Select Case ch
                Case vbCr
                    s = s & line
                    line = vbNullString
                    ch = vbNewLine
                Case vbLf
                    ch = vbNullString
                Case "/"
                    bProbStart = True
                Case "*"
                    bProbEnd = True
                Case Else
            End Select
            line = line & ch
        Next
        AnulaMarcadoresAnsiC = s & line
    End If
End Function



