VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLib_OptCMax"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long

Private Type Color
    Back As Long
    Fore As Long
    Font As Long
End Type
Private c(0 To 17) As Color
Private sFile As String

Private displayWhiteSpace As Boolean
Private fontName As String
Private fontSize As Integer
Private autoIndentMode As Integer
Private tabSize As Integer
Private expandTabs As Boolean
Private normalizeCase As Boolean
Private smoothScrolling As Boolean
Private displayLeftMargin As Boolean
Private lineToolTips As Boolean
Private enableDragDrop As Boolean
Private enableColumnSel As Boolean
Private overtypeCaret As Boolean
Private colorSyntax As Boolean
Private hScrollVisible As Boolean
Private vScrollVisible As Boolean
Private enableHSplitter As Boolean
Private enableVSplitter As Boolean
Private lineNumbering As Boolean
Private globals As CodeMaxCtl.globals
Private lang As CodeMaxCtl.Language

Private Sub Class_Initialize()
    Set lang = New CodeMaxCtl.Language
    Set globals = New CodeMaxCtl.globals
   
    #If DEBUG_ExtendLogOut Then
        Logout "clsOptCMax.Class_Initialize"
    #End If
'On Error Resume Next
    sFile = App.Path & "\Coder.ini"
    displayWhiteSpace = ReadBoolReg("displayWhiteSpace", False)
    fontName = GetSetting(App.Title, "cMax", "fontName", "Courier New")
    fontSize = GetSetting(App.Title, "cMax", "fontSize", 10)
    autoIndentMode = GetSetting(App.Title, "cMax", "autoIndentMode", cmIndentScope)
    tabSize = GetSetting(App.Title, "cMax", "tabSize", 4)
    expandTabs = ReadBoolReg("expandTabs", True)
    normalizeCase = False 'ReadBoolReg("normalizeCase", False)
    smoothScrolling = ReadBoolReg("smoothScrolling", False)
    displayLeftMargin = ReadBoolReg("displayLeftMargin", False)
    lineToolTips = ReadBoolReg("lineToolTips", False)
    enableDragDrop = ReadBoolReg("enableDragDrop", True)
    enableColumnSel = ReadBoolReg("enableColumnSel", False)
    overtypeCaret = ReadBoolReg("overtypeCaret", True)
    colorSyntax = ReadBoolReg("colorSyntax", True)
    hScrollVisible = ReadBoolReg("hScrollVisible", True)
    vScrollVisible = ReadBoolReg("vScrollVisible", True)
    enableHSplitter = ReadBoolReg("enableHSplitter", True)
    enableVSplitter = ReadBoolReg("enableVSplitter", True)
    lineNumbering = ReadBoolReg("lineNumbering", True)
    
    ReadColors
    RegisterCustomLanguage
    #If DEBUG_ExtendLogOut Then
        Logout "clsOptCMax.Class_Initialize, end"
    #End If
  
End Sub

Private Sub Class_Terminate()
    #If DEBUG_ExtendLogOut Then
        Logout "clsOptCMax.Class_Terminate"
    #End If

    SaveSetting App.Title, "cMax", "displayWhiteSpace", displayWhiteSpace
    SaveSetting App.Title, "cMax", "fontName", fontName
    SaveSetting App.Title, "cMax", "fontSize", fontSize
    SaveSetting App.Title, "cMax", "autoIndentMode", autoIndentMode
    SaveSetting App.Title, "cMax", "tabSize", tabSize
    SaveSetting App.Title, "cMax", "expandTabs", expandTabs
    SaveSetting App.Title, "cMax", "normalizeCase", normalizeCase
    SaveSetting App.Title, "cMax", "smoothScrolling", smoothScrolling
    SaveSetting App.Title, "cMax", "displayLeftMargin", displayLeftMargin
    SaveSetting App.Title, "cMax", "lineToolTips", lineToolTips
    SaveSetting App.Title, "cMax", "enableDragDrop", enableDragDrop
    SaveSetting App.Title, "cMax", "enableColumnSel", enableColumnSel
    SaveSetting App.Title, "cMax", "overtypeCaret", overtypeCaret
    SaveSetting App.Title, "cMax", "colorSyntax", colorSyntax
    SaveSetting App.Title, "cMax", "hScrollVisible", hScrollVisible
    SaveSetting App.Title, "cMax", "vScrollVisible", vScrollVisible
    SaveSetting App.Title, "cMax", "enableHSplitter", enableHSplitter
    SaveSetting App.Title, "cMax", "enableVSplitter", enableVSplitter
    SaveSetting App.Title, "cMax", "lineNumbering", lineNumbering
    SaveColors
End Sub

Private Function ReadINI(sSection As String, sKeyName As String, sDefault As String, sFilename As String) As String
Dim sRet As String
    sRet = String$(255, Chr$(0))
    ReadINI = Left$(sRet, GetPrivateProfileString(sSection, ByVal sKeyName, ByVal sDefault, sRet, Len(sRet), sFilename))
End Function

Private Sub WriteINI(sSection As String, sKeyName As String, sNewString As String, sFilename As String)
    WritePrivateProfileString sSection, sKeyName, sNewString, sFilename
End Sub

Private Function ReadBoolReg(sKeyName As String, sDefault As Boolean) As Boolean
    On Error GoTo ControlError
    ReadBoolReg = GetSetting(App.Title, "cMax", sKeyName, sDefault)
    On Error GoTo 0

Exit Function ' Salir para evitar el controlador.
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case 13
            #If DEBUG_ExtendLogOut Then
                Logout " clsOptCMax.WriteBoolReg, sKeyName=" & sKeyName & ": Error #" & Str$(Err.Number) & _
                ": " & Err.Description
            #End If
            ReadBoolReg = sDefault
            Err.Clear
        Case Else
            Logout " clsOptCMax.WriteBoolReg, sKeyName=" & sKeyName & ": Error #" & Str$(Err.Number) & _
            ": " & Err.Description
            Error Err.Number
    End Select
End Function

Private Sub SaveColors()
Dim i As Long
Dim s As String
    
    #If DEBUG_ExtendLogOut Then
        Logout "clsOptCMax.SaveColors"
    #End If

    For i = 0 To 17
        s = c(i).Back
        WriteINI "Colors", "clr" & Format$(i) & "bg", s, sFile
        s = c(i).Fore
        WriteINI "Colors", "clr" & Format$(i) & "fr", s, sFile
        s = c(i).Font
        WriteINI "Colors", "clr" & Format$(i) & "fnt", s, sFile
    Next
End Sub

Private Sub ReadColors()
Dim i As Long

    #If DEBUG_ExtendLogOut Then
        Logout "clsOptCMax.ReadColors"
    #End If

    On Error GoTo errINI
    For i = 0 To 17
        c(i).Back = ReadINI("Colors", "clr" & Format$(i) & "bg", vbNullString, sFile)
        c(i).Fore = ReadINI("Colors", "clr" & Format$(i) & "fr", vbNullString, sFile)
        c(i).Font = ReadINI("Colors", "clr" & Format$(i) & "fnt", vbNullString, sFile)
    Next

Exit Sub
errINI:
    LoadDefaultColors
    MsgBox "Application INI File was damaged. Working default values."
End Sub

Private Function ReadListOf(itemName As String, baseIdentifier As String) As String
Dim i As Long
Dim s As String
Dim s0 As String
    On Error GoTo errINI
    Do
        i = i + 1
        s0 = ReadINI(itemName, baseIdentifier & Format$(i), vbNullString, sFile)
        If LenB(s0) = 0 Then Exit Do
        s = s & vbLf & s0
    Loop
    If LenB(s) Then
        ReadListOf = Mid$(s, 2)
    End If
Exit Function
errINI:
End Function

Private Sub LoadDefaultColors()
    ' ReCreate and ReWrite the values in the INI Files
    ' Just in case someone tries to act smart and
    ' delete my Hard Work
    c(0).Back = -1:         c(0).Fore = -1:         c(0).Font = 0
    c(1).Back = -1:         c(1).Fore = 32768:      c(1).Font = 2
    c(2).Back = 0:          c(2).Fore = 16777215:   c(2).Font = 0
    c(3).Back = 0:          c(3).Fore = 16777215:   c(3).Font = 0
    c(4).Back = 0:          c(4).Fore = 65535:      c(4).Font = 0
    c(5).Back = -1:         c(5).Fore = 16711680:   c(5).Font = 1
    c(6).Back = 0:          c(6).Fore = 16777215:   c(6).Font = 0
    c(7).Back = 10526880:   c(7).Fore = 1052688:    c(7).Font = 0
    c(8).Back = -1:         c(8).Fore = 0:          c(8).Font = 0
    c(9).Back = -1:         c(9).Fore = 255:        c(9).Font = 0
    c(10).Back = -1:        c(10).Fore = 16711680:  c(10).Font = 0
    c(11).Back = -1:        c(11).Fore = 8388736:   c(11).Font = 0
    c(12).Back = -1:        c(12).Fore = 128:       c(12).Font = 0
    c(13).Back = -1:        c(13).Fore = 255:       c(13).Font = 0
    c(14).Back = -1:        c(14).Fore = 16711680:  c(14).Font = 0
    c(15).Back = -1:        c(15).Fore = 0:         c(15).Font = 1
    c(16).Back = -1:        c(16).Fore = 0:         c(16).Font = 0
    c(17).Back = 0:         c(17).Fore = 16777215:  c(17).Font = 0
    SaveColors
 
End Sub

Private Sub RegisterCustomLanguage()
Dim hkF2 As New CodeMaxCtl.HotKey
    
    #If DEBUG_ExtendLogOut Then
        Logout "clsOptCMax.RegisterCustomLanguage"
    #End If
    
    lang.caseSensitive = True
    
    lang.Keywords = ReadListOf("keywords", "k")
    lang.Style = cmLangStyleProcedural
    lang.Operators = ReadListOf("operators", "o")
    lang.SingleLineComments = ReadListOf("singleLineComments", "c")
    lang.MultiLineComments1 = ReadListOf("multiLineCommentsStart", "c")
    lang.MultiLineComments2 = ReadListOf("multiLineCommentsEnd", "c")
    lang.ScopeKeywords1 = ReadListOf("scopeKeywordsStart", "s")
    lang.ScopeKeywords2 = ReadListOf("scopeKeywordsEnd", "s")
    lang.StringDelims = ReadListOf("stringDelims", "d")
    lang.EscapeChar = ReadListOf("escapeChar", "c")
    lang.TerminatorChar = ReadListOf("terminatorChar", "c")
    lang.TagAttributeNames = ReadListOf("tagAttributeNames", "a")
    lang.TagElementNames = ReadListOf("tagElementNames", "e")
    lang.TagEntities = ReadListOf("tagEntities", "e")

    globals.UnregisterAllLanguages
    globals.RegisterLanguage "my_C", lang
    
    'Left F2 key unasigned to be used in Repository
    hkF2.VirtKey1 = Chr$(vbKeyF2)
    globals.UnregisterHotKey hkF2
    
End Sub

Public Sub GetConfig(cMax As CodeMax)
    'Fixed Settings
    'RegisterCustomLanguage
    cMax.Language = "my_C"
    cMax.LineNumberStyle = cmDecimal
    
    'Configurable Settings
    cMax.displayWhiteSpace = displayWhiteSpace
    cMax.Font.Name = fontName
    cMax.Font.size = fontSize
    cMax.autoIndentMode = autoIndentMode
    cMax.tabSize = tabSize
    cMax.expandTabs = expandTabs
    cMax.normalizeCase = normalizeCase
    cMax.smoothScrolling = smoothScrolling
    cMax.displayLeftMargin = displayLeftMargin
    cMax.lineToolTips = lineToolTips
    cMax.enableDragDrop = enableDragDrop
    cMax.enableColumnSel = enableColumnSel
    cMax.overtypeCaret = overtypeCaret
    cMax.colorSyntax = colorSyntax
    cMax.hScrollVisible = hScrollVisible
    cMax.vScrollVisible = vScrollVisible
    cMax.enableHSplitter = enableHSplitter
    cMax.enableVSplitter = enableVSplitter
    cMax.lineNumbering = lineNumbering

    'Use the color data from the ini file
    cMax.SetColor cmClrBookmark, c(0).Fore
    cMax.SetColor cmClrBookmarkBk, c(0).Back
    cMax.SetColor cmClrCommentBk, c(1).Back
    cMax.SetColor cmClrComment, c(1).Fore
    cMax.SetColor cmClrHDividerLines, c(2).Fore
    cMax.SetColor cmClrVDividerLines, c(3).Fore
    cMax.SetColor cmClrHighlightedLine, c(4).Fore
    cMax.SetColor cmClrKeyword, c(5).Fore
    cMax.SetColor cmClrKeywordBk, c(5).Back
    cMax.SetColor cmClrLeftMargin, c(6).Fore
    cMax.SetColor cmClrLineNumber, c(7).Fore
    cMax.SetColor cmClrLineNumberBk, c(7).Back
    cMax.SetColor cmClrNumber, c(8).Fore
    cMax.SetColor cmClrNumberBk, c(8).Back
    cMax.SetColor cmClrOperator, c(9).Fore
    cMax.SetColor cmClrOperatorBk, c(9).Back
    cMax.SetColor cmClrScopeKeyword, c(10).Fore
    cMax.SetColor cmClrScopeKeywordBk, c(10).Back
    cMax.SetColor cmClrString, c(11).Fore
    cMax.SetColor cmClrStringBk, c(11).Back
    cMax.SetColor cmClrTagElementName, c(12).Fore
    cMax.SetColor cmClrTagElementNameBk, c(12).Back
    cMax.SetColor cmClrTagEntity, c(13).Fore
    cMax.SetColor cmClrTagEntityBk, c(13).Back
    cMax.SetColor cmClrTagAttributeName, c(14).Fore
    cMax.SetColor cmClrTagAttributeNameBk, c(14).Back
    cMax.SetColor cmClrTagText, c(15).Fore
    cMax.SetColor cmClrTagTextBk, c(15).Back
    cMax.SetColor cmClrText, c(16).Fore
    cMax.SetColor cmClrTextBk, c(16).Back
    'cMax.SetColor cmClrWindow, c(17).Fore
    
    'Setup font styles
    cMax.SetFontStyle cmStyComment, c(1).Font
    cMax.SetFontStyle cmStyLineNumber, c(7).Font
    cMax.SetFontStyle cmStyNumber, c(8).Font
    cMax.SetFontStyle cmStyOperator, c(9).Font
    cMax.SetFontStyle cmStyScopeKeyword, c(10).Font
    cMax.SetFontStyle cmStyString, c(11).Font
    cMax.SetFontStyle cmStyTagAttributeName, c(12).Font
    cMax.SetFontStyle cmStyTagAttributeName, c(13).Font
    cMax.SetFontStyle cmStyTagEntity, c(14).Font
    cMax.SetFontStyle cmStyKeyword, c(5).Font
    cMax.SetFontStyle cmStyTagText, c(15).Font
    cMax.SetFontStyle cmStyNumber, c(8).Font
    cMax.SetFontStyle cmStyText, c(16).Font
End Sub

Public Sub SetConfig(cMax As CodeMax)
    'Configurable Settings
    displayWhiteSpace = cMax.displayWhiteSpace
    fontName = cMax.Font.Name
    fontSize = cMax.Font.size
    autoIndentMode = cMax.autoIndentMode
    tabSize = cMax.tabSize
    expandTabs = cMax.expandTabs
    normalizeCase = cMax.normalizeCase
    smoothScrolling = cMax.smoothScrolling
    displayLeftMargin = cMax.displayLeftMargin
    lineToolTips = cMax.lineToolTips
    enableDragDrop = cMax.enableDragDrop
    enableColumnSel = cMax.enableColumnSel
    overtypeCaret = cMax.overtypeCaret
    colorSyntax = cMax.colorSyntax
    hScrollVisible = cMax.hScrollVisible
    vScrollVisible = cMax.vScrollVisible
    enableHSplitter = cMax.enableHSplitter
    enableVSplitter = cMax.enableVSplitter
    lineNumbering = cMax.lineNumbering

    'Use the color data from the ini file
    c(0).Fore = cMax.GetColor(cmClrBookmark)
    c(0).Back = cMax.GetColor(cmClrBookmarkBk)
    c(1).Back = cMax.GetColor(cmClrCommentBk)
    c(1).Fore = cMax.GetColor(cmClrComment)
    c(2).Fore = cMax.GetColor(cmClrHDividerLines)
    c(3).Fore = cMax.GetColor(cmClrVDividerLines)
    c(4).Fore = cMax.GetColor(cmClrHighlightedLine)
    c(5).Fore = cMax.GetColor(cmClrKeyword)
    c(5).Back = cMax.GetColor(cmClrKeywordBk)
    c(6).Fore = cMax.GetColor(cmClrLeftMargin)
    c(7).Fore = cMax.GetColor(cmClrLineNumber)
    c(7).Back = cMax.GetColor(cmClrLineNumberBk)
    c(8).Fore = cMax.GetColor(cmClrNumber)
    c(8).Back = cMax.GetColor(cmClrNumberBk)
    c(9).Fore = cMax.GetColor(cmClrOperator)
    c(9).Back = cMax.GetColor(cmClrOperatorBk)
    c(10).Fore = cMax.GetColor(cmClrScopeKeyword)
    c(10).Back = cMax.GetColor(cmClrScopeKeywordBk)
    c(11).Fore = cMax.GetColor(cmClrString)
    c(11).Back = cMax.GetColor(cmClrStringBk)
    c(12).Fore = cMax.GetColor(cmClrTagElementName)
    c(12).Back = cMax.GetColor(cmClrTagElementNameBk)
    c(13).Fore = cMax.GetColor(cmClrTagEntity)
    c(13).Back = cMax.GetColor(cmClrTagEntityBk)
    c(14).Fore = cMax.GetColor(cmClrTagAttributeName)
    c(14).Back = cMax.GetColor(cmClrTagAttributeNameBk)
    c(15).Fore = cMax.GetColor(cmClrTagText)
    c(15).Back = cMax.GetColor(cmClrTagTextBk)
    c(16).Fore = cMax.GetColor(cmClrText)
    c(16).Back = cMax.GetColor(cmClrTextBk)
    'c(17).Fore = cMax.GetColor(cmClrWindow)
    
    'Setup font styles
    c(1).Font = cMax.GetFontStyle(cmStyComment)
    c(7).Font = cMax.GetFontStyle(cmStyLineNumber)
    c(8).Font = cMax.GetFontStyle(cmStyNumber)
    c(9).Font = cMax.GetFontStyle(cmStyOperator)
    c(10).Font = cMax.GetFontStyle(cmStyScopeKeyword)
    c(11).Font = cMax.GetFontStyle(cmStyString)
    c(12).Font = cMax.GetFontStyle(cmStyTagAttributeName)
    c(13).Font = cMax.GetFontStyle(cmStyTagAttributeName)
    c(14).Font = cMax.GetFontStyle(cmStyTagEntity)
    c(5).Font = cMax.GetFontStyle(cmStyKeyword)
    c(15).Font = cMax.GetFontStyle(cmStyTagText)
    c(8).Font = cMax.GetFontStyle(cmStyNumber)
    c(16).Font = cMax.GetFontStyle(cmStyText)
    
End Sub

